#include <windows.h>

#include "common.h"
#include "divider.h"

#define DIVIDER_WIDTH 4

struct dwval{
	int type;	// c
	HWND wnd[2];	// EBhE
	int div;	// Ëʒu
	int diff;	// ړ̃}EXJ[\ƃfBoC_[̈ʒu
};

void setWindowsSize(HWND hWnd, struct dwval* dwv)
{
	RECT rc;
	int wx, wy;
	int div = dwv->div;

	GetClientRect(hWnd, &rc);
	wx = rc.right - rc.left;	// rc.leftȂĂGetClientRect0Ȃ񂾂ǁB
	wy = rc.bottom - rc.top;	// rc.topB

	switch(dwv->type)
	{
	case DIVIDER_VERTICAL:
		if(wx - DIVIDER_WIDTH < div)
			div = wx - DIVIDER_WIDTH;
		if(dwv->wnd[0])
			SetWindowPos(dwv->wnd[0], NULL, 0, 0, div, wy, SWP_NOZORDER);
		if(dwv->wnd[1])
			SetWindowPos(dwv->wnd[1], NULL, div + DIVIDER_WIDTH, 0, wx - div - DIVIDER_WIDTH, wy, SWP_NOZORDER);
		break;
	case DIVIDER_HORIZONTAL:
		if(wy - DIVIDER_WIDTH < div)
			div = wy - DIVIDER_WIDTH;
		if(dwv->wnd[0])
			SetWindowPos(dwv->wnd[0], NULL, 0, 0, wx, div, SWP_NOZORDER);
		if(dwv->wnd[1])
			SetWindowPos(dwv->wnd[1], NULL, 0, div + DIVIDER_WIDTH, wx, wy - div - DIVIDER_WIDTH, SWP_NOZORDER);
		break;
	}

	return;
}

LRESULT CALLBACK dividerWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	//struct dwval* dwv = (struct dwval*)GetWindowLong(hWnd, 0);

	switch(msg)
	{
	case WM_CREATE:
		{
			struct dwval* dwv;

			if(!(dwv = halloc(sizeof(struct dwval))))
				return -1;	// CreateFail

			SetWindowLong(hWnd, 0, (LONG)dwv);
			dwv->type = (int)((CREATESTRUCT*)lParam)->lpCreateParams;
			dwv->div = 200;	// Ԃ炢ɂƂp[^set...
			dwv->wnd[0] = NULL;
			dwv->wnd[1] = NULL;
		}
		break;
	case WM_DESTROY:
		hfree((void*)GetWindowLong(hWnd, 0));
		break;

	case WM_MOUSEMOVE:
		{
			struct dwval* dwv = (struct dwval*)GetWindowLong(hWnd, 0);
			RECT rc;

			GetClientRect(hWnd, &rc);

			switch(dwv->type)
			{
			case DIVIDER_VERTICAL:
				SetCursor(LoadCursor(NULL, IDC_SIZEWE));
				break;
			case DIVIDER_HORIZONTAL:
				SetCursor(LoadCursor(NULL, IDC_SIZENS));
				break;
			}

			if(GetCapture() == hWnd)
			{
				switch(dwv->type)
				{
				case DIVIDER_VERTICAL:		
					dwv->div = (short)LOWORD(lParam) - dwv->diff;	
					if(dwv->div < 0)
						dwv->div = 0;
					if(rc.right - DIVIDER_WIDTH < dwv->div)
						dwv->div = rc.right - DIVIDER_WIDTH;
					break;
				case DIVIDER_HORIZONTAL:
					dwv->div = (short)HIWORD(lParam) - dwv->diff;	
					if(dwv->div < 0)
						dwv->div = 0;
					if(rc.bottom - DIVIDER_WIDTH < dwv->div)
						dwv->div = rc.bottom - DIVIDER_WIDTH;
					break;
				}
				setWindowsSize(hWnd, dwv);
			}
		}
		break;
	case WM_LBUTTONDOWN:
		{
			struct dwval* dwv = (struct dwval*)GetWindowLong(hWnd, 0);

			SetCapture(hWnd);

			{
				RECT rc;
				int wx, wy;

				GetClientRect(hWnd, &rc);
				wx = rc.right - rc.left;	// rc.leftȂĂGetClientRect0Ȃ񂾂ǁB
				wy = rc.bottom - rc.top;	// rc.topB

				switch(dwv->type)
				{
				case DIVIDER_VERTICAL:
					if(wx - DIVIDER_WIDTH < dwv->div)
						dwv->div = wx - DIVIDER_WIDTH;
					break;
				case DIVIDER_HORIZONTAL:
					if(wy - DIVIDER_WIDTH < dwv->div)
						dwv->div = wy - DIVIDER_WIDTH;
					break;
				}
			}

			switch(dwv->type)
			{
			case DIVIDER_VERTICAL:		dwv->diff = LOWORD(lParam) - dwv->div;	break;
			case DIVIDER_HORIZONTAL:	dwv->diff = HIWORD(lParam) - dwv->div;	break;
			}
		}
		break;
	case WM_LBUTTONUP:
		ReleaseCapture();
		break;

	case WM_USER:
		switch(HIWORD(wParam))
		{
		case 0:	// set
			{
				struct dwval* dwv = (struct dwval*)GetWindowLong(hWnd, 0);

				if(2 <= LOWORD(wParam))
					return (LRESULT)NULL;

				dwv->wnd[LOWORD(wParam)] = (HWND)lParam;

				setWindowsSize(hWnd, dwv);

				return lParam;
			}
			break;
		case 1:	// get
			{
				struct dwval* dwv = (struct dwval*)GetWindowLong(hWnd, 0);

				if(2 <= LOWORD(wParam))
					return (LRESULT)NULL;

				return (LRESULT)dwv->wnd[LOWORD(wParam)];
			}
		}

		break;

	case WM_SIZE:
		{
			struct dwval* dwv = (struct dwval*)GetWindowLong(hWnd, 0);

			setWindowsSize(hWnd, dwv);
		}
		break;

	case WM_KEYDOWN:
	case WM_KEYUP:
		// Ɋۓ
		return SendMessage(GetParent(hWnd), msg, wParam, lParam);
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

BOOL dividerInit(void)
{
	WNDCLASSEX wc = {0};

	wc.cbSize = sizeof(wc);
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
	wc.cbWndExtra = sizeof(void*);
	wc.hInstance = GetModuleHandle(NULL);
	wc.lpfnWndProc = dividerWndProc;
	wc.lpszClassName = WC_DIVIDER;

	if(!RegisterClassEx(&wc))
		return FALSE;

	return TRUE;
}

void dividerTerminate(void)
{
	return;
}
