/*
 *
 *  SCOOPER - Remake of PickWall
 *         by Murachue
 *
 *  This is main.c with OMAKE.
 *
 */

#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include "resource.h"

#include "common.h"
#include "rstring.h"
#include "divider.h"
#include "toolist.h"
#include "dirrefer.h"
#include "spi.h"
#include "pikture.h"
#include "main.h"
#include "version.h"
#include "spisett.h"

// {common.hsAcommctrl.hKvȂmain.cɁB
#ifndef ListView_SetCheckState
   #define ListView_SetCheckState(hwndLV, i, fCheck) \
      ListView_SetItemState(hwndLV, i, \
      INDEXTOSTATEIMAGEMASK((fCheck)+1), LVIS_STATEIMAGEMASK)
#endif

TCHAR gSpiDir[MAX_PATH];

struct tagMainWndVal{
	HWND hDividerWnd;
	HWND hStatusWnd;
	DWORD tidFind;
	LPCONTEXTMENU2 cm2;
};

enum{
	COND_EQUAL,
	COND_NOTEQUAL,
	COND_EQUALORGREATER,
	COND_EQUALORLESSER,
	COND_GREATER,
	COND_LESSER,
};
LPCTSTR ConditionTextList[] = {TEXT("=="), TEXT("!="), TEXT("<="), TEXT(">="), TEXT("<"), TEXT(">"), NULL};
typedef struct{
	UINT width;
	UINT height;
	int cond;
}ConditionItem;

typedef struct tagConditionSet{
	LPTSTR name;

	UINT itemcount;
	ConditionItem** items;

	struct tagConditionSet* next;
}ConditionSet;

struct tagOption Option;

SUSIEPLUGIN* SPIroot = NULL;
ConditionSet* CondSetroot = NULL;

// TODO: [
BOOL CALLBACK NullDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			VERSION v;
			TCHAR ts[64];

			getVersion(&v);

			wsprintf(ts, TEXT("Version %d.%d.%d.%d"), v.major, v.minor, v.patch, v.build);

			SetDlgItemText(hWnd, IDC_VERSION, ts);
		}

		{
			RECT crc, wrc;

			GetClientRect(GetParent(hWnd), &crc);
			ClientToScreen(GetParent(hWnd), (POINT*)&crc);
			ClientToScreen(GetParent(hWnd), (POINT*)&crc + 1);

			GetWindowRect(hWnd, &wrc);

			SetWindowPos(hWnd, NULL, crc.left + (crc.right - crc.left - (wrc.right - wrc.left)) / 2, crc.top + (crc.bottom - crc.top - (wrc.bottom - wrc.top)) / 2, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
		}

		return TRUE;
	case WM_COMMAND:
		if(LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
			SendMessage(hWnd, WM_CLOSE, 0, 0);
#ifdef OMAKE
		if(LOWORD(wParam) == IDC_APPICON)
		{
			if(MessageBox(hWnd, String(IDS_SHALLITIUNTIUN), String(IDS_CONFIRM), MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2) == IDYES)
			{
				PlaySound(MAKEINTRESOURCE(IDR_TIUNTIUN), GetModuleHandle(NULL), SND_ASYNC | SND_RESOURCE);

				((void (*)(void))0)();	// TiunTiun
			}
		}
#endif
		break;
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		break;
	}

	return FALSE;
}

struct tagAddconditionDlgVal{
	HWND hListWnd;

	// ȉҏWp
	UINT id;
};

BOOL CALLBACK AddconditionDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			struct tagAddconditionDlgVal* adv = (struct tagAddconditionDlgVal*)lParam;

			SetWindowLong(hWnd, DWL_USER, (LONG)lParam);

			{
				POINT p = {0, 0};

				ClientToScreen(adv->hListWnd, &p);
				if(adv->id != -1)
				{
					RECT rc;

					ListView_GetItemRect(adv->hListWnd, adv->id, &rc, LVIR_BOUNDS);
					p.x += rc.left;
					p.y += rc.top;
				}
				SetWindowPos(hWnd, NULL, p.x, p.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
				EnableWindow(GetParent(hWnd), TRUE);
				//SetForegroundWindow(hWnd);
			}

			// R{{bNXIǉ
			// NOTICE: enum COND_*̏ɂȂ΂ȂȂ
			{
				int i;

				for(i = 0; ConditionTextList[i]; i++)
				{
					SendMessage(GetDlgItem(hWnd, IDC_COND), CB_ADDSTRING, 0, (LPARAM)ConditionTextList[i]);
				}
			}
			// ftHg1ԖڂI
			SendMessage(GetDlgItem(hWnd, IDC_COND), CB_SETCURSEL, 0, 0);

			if(adv->id != -1)
			{	// ҏW:擾ăZbg
				LV_ITEM lvi;
				ConditionItem* ci;

				lvi.mask = LVIF_PARAM;
				lvi.iItem = adv->id;
				lvi.iSubItem = 0;

				ListView_GetItem(adv->hListWnd, &lvi);

				ci = (ConditionItem*)lvi.lParam;

				SetDlgItemInt(hWnd, IDC_W, ci->width, FALSE);
				SetDlgItemInt(hWnd, IDC_H, ci->height, FALSE);
				SendMessage(GetDlgItem(hWnd, IDC_COND), CB_SETCURSEL, ci->cond, 0);
			}
		}
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			// list set
			{
				LV_ITEM lvi;
				TCHAR ts[32];
				struct tagAddconditionDlgVal* adv = (struct tagAddconditionDlgVal*)GetWindowLong(hWnd, DWL_USER);
				HWND hListWnd = adv->hListWnd;

				lvi.mask = LVIF_TEXT | LVIF_PARAM;
				lvi.iSubItem = 0;
				{
					ConditionItem* ci;

					ci = halloc(sizeof(ConditionItem));

					ci->width = GetDlgItemInt(hWnd, IDC_W, NULL, FALSE);
					ci->height = GetDlgItemInt(hWnd, IDC_H, NULL, FALSE);
					ci->cond = SendMessage(GetDlgItem(hWnd, IDC_COND), CB_GETCURSEL, 0, 0);

					lvi.lParam = (LPARAM)ci;

					wsprintf(ts, TEXT("%d x %d"), ci->width, ci->height);
				}
				lvi.pszText = ts;

				if(adv->id == -1)
				{
					lvi.iItem = ListView_GetItemCount(hListWnd);
					ListView_InsertItem(hListWnd, &lvi);
				}else
				{
					lvi.iItem = adv->id;
					ListView_DeleteItem(hListWnd, adv->id);	// ̂
					ListView_InsertItem(hListWnd, &lvi);
				}

				GetWindowText(GetDlgItem(hWnd, IDC_COND), ts, sizeof(ts));
				ListView_SetItemText(hListWnd, lvi.iItem, 1, ts);

				hfree(adv);
			}

			SetWindowLong(hWnd, DWL_USER, (LONG)0);	// Win9x΍

			EndDialog(hWnd, 0);

			break;
		case IDCANCEL:
			{
				struct tagAddconditionDlgVal* adv = (struct tagAddconditionDlgVal*)GetWindowLong(hWnd, DWL_USER);

				hfree(adv);
			}

			SetWindowLong(hWnd, DWL_USER, (LONG)0);	// Win9x΍

			EndDialog(hWnd, 0);
			break;
		}
		break;
	case WM_CLOSE:
		SendMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
		break;

	case WM_ACTIVATE:
		if(GetWindowLong(hWnd, DWL_USER) && LOWORD(wParam) == FALSE)	// Win9x΍: GetWindowLongWin95,98œ߂technique
			SendMessage(hWnd, WM_CLOSE, 0, 0);
		break;
	}

	return FALSE;
}

struct tagAddexcludeDlgVal{
	HWND hListWnd;

	// ȉҏWp
	UINT id;
};

BOOL CALLBACK AddexcludeDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			struct tagAddexcludeDlgVal* edv = (struct tagAddexcludeDlgVal*)lParam;

			SetWindowLong(hWnd, DWL_USER, (LONG)lParam);

			{
				POINT p = {0, 0};

				ClientToScreen(edv->hListWnd, &p);
				if(edv->id != -1)
				{
					RECT rc;

					ListView_GetItemRect(edv->hListWnd, edv->id, &rc, LVIR_BOUNDS);
					p.x += rc.left;
					p.y += rc.top;
				}
				SetWindowPos(hWnd, NULL, p.x, p.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
				EnableWindow(GetParent(hWnd), TRUE);
				//SetForegroundWindow(hWnd);
			}

			if(edv->id != -1)
			{	// ҏW: 擾ăZbg
				TCHAR ts[MAX_PATH];

				ListView_GetItemText(edv->hListWnd, edv->id, 0, ts, sizeof(ts));
				SetDlgItemText(hWnd, IDC_DIR, ts);
			}
		}

		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			// list set
			{
				LV_ITEM lvi;
				TCHAR ts[MAX_PATH];
				struct tagAddexcludeDlgVal* edv = (struct tagAddexcludeDlgVal*)GetWindowLong(hWnd, DWL_USER);
				HWND hListWnd = edv->hListWnd;

				lvi.mask = LVIF_TEXT;
				lvi.iSubItem = 0;
				GetDlgItemText(hWnd, IDC_DIR, ts, sizeof(ts));
				lvi.pszText = ts;

				if(edv->id == -1)
				{
					lvi.iItem = ListView_GetItemCount(hListWnd);
					ListView_InsertItem(hListWnd, &lvi);
				}else
				{
					lvi.iItem = edv->id;
					ListView_SetItem(hListWnd, &lvi);	// ͉̕KvȂ
				}

				hfree(edv);
			}

			SetWindowLong(hWnd, DWL_USER, (LONG)0);	// Win9x΍

			EndDialog(hWnd, 0);

			break;
		case IDCANCEL:
			{
				struct tagAddexcludeDlgVal* edv = (struct tagAddexcludeDlgVal*)GetWindowLong(hWnd, DWL_USER);

				hfree(edv);
			}

			SetWindowLong(hWnd, DWL_USER, (LONG)0);	// Win9x΍

			EndDialog(hWnd, 0);
			break;
		case IDC_REFER:
			{
				TCHAR path[MAX_PATH];

				if(BrowseFolder(hWnd, path))
				{
					int len;

					SetDlgItemText(hWnd, IDC_DIR, path);
					len = SendMessage(GetDlgItem(hWnd, IDC_DIR), WM_GETTEXTLENGTH, 0, 0);
					SendMessage(GetDlgItem(hWnd, IDC_DIR), EM_SETSEL, len, len);
					SetFocus(GetDlgItem(hWnd, IDC_DIR));
				}
			}
			break;
		}
		break;
	case WM_CLOSE:
		SendMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
		break;

	case WM_ACTIVATE:
		if(GetWindowLong(hWnd, DWL_USER) && LOWORD(wParam) == FALSE)	// Win9x΍: GetWindowLongWin95,98œ߂technique
			SendMessage(hWnd, WM_CLOSE, 0, 0);
		break;
	}

	return FALSE;
}

BOOL CALLBACK savecondDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		SetWindowLong(hWnd, DWL_USER, /*(LONG)lParam*/1);

		{
			POINT p = {0, 0};

			ClientToScreen((HWND)lParam, &p);
			SetWindowPos(hWnd, NULL, p.x, p.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			EnableWindow(GetParent(hWnd), TRUE);
			//SetForegroundWindow(hWnd);
		}

		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			// list set
			{
				LPTSTR text;
				DWORD len;

				len = GetDlgItemTextLength(hWnd, IDC_NAME);
				text = halloc((len + 1) * sizeof(TCHAR));
				GetDlgItemText(hWnd, IDC_NAME, text, (len + 1) * sizeof(TCHAR));

				SetWindowLong(hWnd, DWL_USER, (LONG)0);	// Win9x΍

				EndDialog(hWnd, (int)text);
			}

			break;
		case IDCANCEL:
			SetWindowLong(hWnd, DWL_USER, (LONG)0);	// Win9x΍

			EndDialog(hWnd, 0);
			break;
		}
		break;
	case WM_CLOSE:
		SendMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
		break;

	case WM_ACTIVATE:
		if(GetWindowLong(hWnd, DWL_USER) && LOWORD(wParam) == FALSE)	// Win9x΍: GetWindowLongWin95,98œ߂technique
			SendMessage(hWnd, WM_CLOSE, 0, 0);
		break;
	}

	return FALSE;
}

BOOL recurseSearcher(HWND hListWnd, HWND hStatusWnd, HWND hCondListWnd, HWND hExcludeListWnd, HWND hMainWnd, UINT* totalfiles, UINT* totalsize, BOOL recurse)
{
	WIN32_FIND_DATA wfd;
	HANDLE hfind;
	// TODO: ܂ȁB[JMAX_PATHƂƂƂԂstack overflowB
	TCHAR cdir[MAX_PATH];
	//DWORD tick;
	BOOL retval = TRUE;

	GetCurrentDirectory(sizeof(cdir), cdir);

	// OpXeXg
	{
		int max = ListView_GetItemCount(hExcludeListWnd), i;

		if(max)
		{
			addEndYen(cdir);
			lstrlwr(cdir);

			for(i = 0; i < max; i++)
			{
				TCHAR exdir[MAX_PATH];	// TODO: stack overflow

				ListView_GetItemText(hExcludeListWnd, i, 0, exdir, sizeof(exdir));
				lstrlwr(exdir);

				if(lstrstr(cdir, exdir))
				{
					return retval;
				}
			}
		}
	}

	// is\
	SendMessage(hStatusWnd, SB_SETTEXT, 255 | SBT_POPOUT, (LPARAM)cdir);

	// 2passŃfBNgŏɏƂ...?
	// TODO: t@CtB^SPIɖ₢킹
	if((hfind = FindFirstFile(TEXT("*.*"), &wfd)) != INVALID_HANDLE_VALUE)
	{
		do{
			{
				MSG msg;

				// WM_APPłĂځ[B
				if((GetAsyncKeyState(VK_ESCAPE) & 0x8000 && GetForegroundWindow() == hMainWnd) || PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) && msg.message == WM_APP)
				{
					retval = FALSE;
					goto die;
				}
			}

			if(!lstrcmp(wfd.cFileName, TEXT(".")) || !lstrcmp(wfd.cFileName, TEXT("..")))
				continue;
			if(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY && recurse)
			{
				// Dir
				BOOL result;

				SetCurrentDirectory(wfd.cFileName);
				result = recurseSearcher(hListWnd, hStatusWnd, hCondListWnd, hExcludeListWnd, hMainWnd, totalfiles, totalsize, recurse);
				SetCurrentDirectory(TEXT(".."));

				if(!result)
				{
					retval = FALSE;
					goto die;
				}
			}else
			{
				// File
				LV_ITEM lvi;
				BOOL added = FALSE;

				lvi.mask = LVIF_TEXT | LVIF_PARAM;
				lvi.iItem = ListView_GetItemCount(hListWnd);
				lvi.iSubItem = 0;
				lvi.pszText = wfd.cFileName;

				if(Option.ListupAllFiles)
				{
					added = TRUE;
					lvi.lParam = ListView_GetItemCount(hListWnd);
					ListView_InsertItem(hListWnd, &lvi);
				}

				// [SusiePluging܂...
				{
					SUSIEPLUGIN* spi;
					HANDLE hf;

					if((hf = CreateFile(wfd.cFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE)
					{
						if(Option.FastScan)
						{	// 
							BYTE tmpbuf[64] = {0};
							TCHAR ext[8];
							LPCTSTR tp;
							SIZE ps = {0, 0};
							DWORD dummy;

							tp = lastchar(wfd.cFileName, TEXT('.'));
							if(tp)	// gq΂
							{
								lstrcpyn(ext, tp + 1, 4 + 1);	// .jpeg
								lstrlwr(ext);

								if(!lstrcmp(ext, TEXT("bmp")))
								{	// BMP!!	LittleEndian DWORD
									SetFilePointer(hf, 0x12, NULL, FILE_BEGIN);
									ReadFile(hf, tmpbuf, 8, &dummy, NULL);

									ps.cx = *(DWORD*)(tmpbuf + 0);
									ps.cy = *(DWORD*)(tmpbuf + 4);
								}
								if(!lstrcmp(ext, TEXT("gif")))
								{	// GIF!!	LittleEndian WORD
									SetFilePointer(hf, 0x06, NULL, FILE_BEGIN);
									ReadFile(hf, tmpbuf, 4, &dummy, NULL);

									ps.cx = *(WORD*)(tmpbuf + 0);
									ps.cy = *(WORD*)(tmpbuf + 2);
								}
								if(!lstrcmp(ext, TEXT("png")))
								{	// PNG!!	BigEndian DWORD
									// TODO: offsetŒ?
									SetFilePointer(hf, 0x10, NULL, FILE_BEGIN);
									ReadFile(hf, tmpbuf, 8, &dummy, NULL);

									ps.cx = BE4(tmpbuf + 0);
									ps.cy = BE4(tmpbuf + 4);
								}
								if(!lstrcmp(ext, TEXT("jpg")) || !lstrcmp(ext, TEXT("jpeg")))
								{	// JPEG!!	BigEndian WORD
									SetFilePointer(hf, 0x02, NULL, FILE_BEGIN);

									// JPEG̃t@CtH[}bgɂĂ"˂"킩₷?Ǝv܂B
									for(;;)
									{
										if(GetFileSize(hf, NULL) <= SetFilePointer(hf, 0, NULL, FILE_CURRENT))	// ڂ
											break;

										ReadFile(hf, tmpbuf, 4, &dummy, NULL);

										if(BE2(tmpbuf) == 0x0D0A)	// ...Does this marker exist?
										{
											SetFilePointer(hf, +2, NULL, FILE_CURRENT);
											continue;
										}
										if(BE2(tmpbuf) == 0xFFD9)
										{	// C[WI[
											MessageBox(hMainWnd, String(IDS_JPEGSOFXNOTFOUND), String(IDS_ERROR), MB_ICONERROR | MB_OK);
											break;
										}
										if(BE2(tmpbuf) != 0xFFC0 && BE2(tmpbuf) != 0xFFC2)
										{	// This is not SOF0 or SOF2.
											SetFilePointer(hf, +BE2(tmpbuf + 2) - 2, NULL, FILE_CURRENT);
											continue;
										}

										// TODO: JPEG Not only SOF0/SOF2. This is ONLY Baseline/Progressive with huffman!

										SetFilePointer(hf, +1, NULL, FILE_CURRENT);

										ReadFile(hf, tmpbuf, 4, &dummy, NULL);

										ps.cy = BE2(tmpbuf + 0);
										ps.cx = BE2(tmpbuf + 2);

										break;
									}
								}

								if(ps.cx && ps.cy)
// TODO: MERGE BELOW
								{
									// TCY
									BOOL hit = FALSE;

									int max = ListView_GetItemCount(hCondListWnd);
									LV_ITEM lvix;

									lvix.mask = LVIF_PARAM;
									lvix.iSubItem = 0;

									for(lvix.iItem = 0; lvix.iItem < max; lvix.iItem++)
									{
										ConditionItem* ci;

										ListView_GetItem(hCondListWnd, &lvix);
										ci = (ConditionItem*)lvix.lParam;

										switch(ci->cond)
										{
										case COND_EQUAL:			if(ci->width == (unsigned long)ps.cx && ci->height == (unsigned long)ps.cy)	hit = TRUE;	break;
										case COND_NOTEQUAL:			if(ci->width != (unsigned long)ps.cx || ci->height != (unsigned long)ps.cy)	hit = TRUE;	break;
										case COND_EQUALORGREATER:	if(ci->width <= (unsigned long)ps.cx && ci->height <= (unsigned long)ps.cy)	hit = TRUE;	break;
										case COND_EQUALORLESSER:	if(ci->width >= (unsigned long)ps.cx && ci->height >= (unsigned long)ps.cy)	hit = TRUE;	break;
										case COND_GREATER:			if(ci->width <  (unsigned long)ps.cx && ci->height <  (unsigned long)ps.cy)	hit = TRUE;	break;
										case COND_LESSER:			if(ci->width >  (unsigned long)ps.cx && ci->height >  (unsigned long)ps.cy)	hit = TRUE;	break;
										}
									}

									if(hit)
									{	// qbĝXgAbv
										TCHAR ts[16];

										if(!Option.ListupAllFiles)
										{
											added = TRUE;
											lvi.lParam = ListView_GetItemCount(hListWnd);
											ListView_InsertItem(hListWnd, &lvi);
										}

										wsprintf(ts, TEXT("%d x %d"), ps.cx, ps.cy);
										ListView_SetItemText(hListWnd, lvi.iItem, 1, ts);

										//ListView_SetItemText(hListWnd, lvi.iItem, 4, spi->ModuleName);
									}
								}
// /TODO
							}
							CloseHandle(hf);
						}else
						{	// ʏ팟
							BYTE tmpbuf[2048] = {0};	// TODO: ȂƂbuffer overflowtO & 0tBSPI̎dl
							DWORD len;

							ReadFile(hf, tmpbuf, 2048, &len, NULL);

							CloseHandle(hf);
							for(spi = SPIroot; spi; spi = spi->next)
							{
								PictureInfo pi = {0};

								// ifjpegmemoryoRGetPictureInfoƗ錏ɂāB
								if(spi->use && spi->IsSupported(wfd.cFileName, (DWORD)tmpbuf) && !spi->GetPictureInfo(/*tmpbuf, len, /*from Memory* /1, &pi*/wfd.cFileName, 0, /*from File*/0, &pi))
								//if(!spi->GetPictureInfo(tmpbuf, len, /*from Memory*/1, &pi))	// 0=Success...XqBȂĂ܂킵[B...ނ
								//if(!spi->GetPictureInfo(wfd.cFileName, 0, /*from File*/0, &pi))	// 0=Success...XqBȂĂ܂킵[B...ނ
// TODO: MERGE ABOVE
								{
									// TCY
									BOOL hit = FALSE;

									int max = ListView_GetItemCount(hCondListWnd);
									LV_ITEM lvix;

									lvix.mask = LVIF_PARAM;
									lvix.iSubItem = 0;

									for(lvix.iItem = 0; lvix.iItem < max; lvix.iItem++)
									{
										ConditionItem* ci;

										ListView_GetItem(hCondListWnd, &lvix);
										ci = (ConditionItem*)lvix.lParam;

										switch(ci->cond)
										{
										case COND_EQUAL:			if(ci->width == (unsigned long)pi.width && ci->height == (unsigned long)pi.height)	hit = TRUE;	break;
										case COND_NOTEQUAL:			if(ci->width != (unsigned long)pi.width || ci->height != (unsigned long)pi.height)	hit = TRUE;	break;
										case COND_EQUALORGREATER:	if(ci->width <= (unsigned long)pi.width && ci->height <= (unsigned long)pi.height)	hit = TRUE;	break;
										case COND_EQUALORLESSER:	if(ci->width >= (unsigned long)pi.width && ci->height >= (unsigned long)pi.height)	hit = TRUE;	break;
										case COND_GREATER:			if(ci->width <  (unsigned long)pi.width && ci->height <  (unsigned long)pi.height)	hit = TRUE;	break;
										case COND_LESSER:			if(ci->width >  (unsigned long)pi.width && ci->height >  (unsigned long)pi.height)	hit = TRUE;	break;
										}
									}

									if(hit)
									{	// qbĝXgAbv
										TCHAR ts[16];

										if(!Option.ListupAllFiles)
										{
											added = TRUE;
											lvi.lParam = ListView_GetItemCount(hListWnd);
											ListView_InsertItem(hListWnd, &lvi);
										}

										wsprintf(ts, TEXT("%d x %d"), pi.width, pi.height);
										ListView_SetItemText(hListWnd, lvi.iItem, 1, ts);

										ListView_SetItemText(hListWnd, lvi.iItem, 4, spi->ModuleName);

										// 킟
										// BUG: Ȃ񂩂HLOCALƂĂ邯...AVĂ邯...{Global...
										//if(pi.hInfo)
										//	GlobalFree(pi.hInfo);

										break;
									}
								}
// /TODO
							}
							if(!spi)
							{	// Didn't handled
								if(Option.ListupAllFiles)
									ListView_SetItemText(hListWnd, lvi.iItem, 1, TEXT("---"));
							}
						}
					}else
					{
						if(Option.ListupAllFiles)
							ListView_SetItemText(hListWnd, lvi.iItem, 1, TEXT("-Err-"));
					}
				}

				if(added)
				{
					TCHAR ts[16];

					// size
					wsprintf(ts, TEXT("%d"), wfd.nFileSizeLow);	// BUG: 4GB܂
					ListView_SetItemText(hListWnd, lvi.iItem, 2, ts);

					// fullpath
					ListView_SetItemText(hListWnd, lvi.iItem, 3, cdir);

					(*totalfiles)++;
					(*totalsize) += wfd.nFileSizeLow;	// TODO: 4GB over
				}
			}
		}while(FindNextFile(hfind, &wfd));
die:
		FindClose(hfind);
	}

	return retval;
}

void makeMainForm(HWND hMainWnd)
{
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hMainWnd, 0);

	// CtH[쐬
	// dividers
	{
		// TODO: dv2dv3͓\
		HWND dv = CreateWindowEx(0, WC_DIVIDER, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, hMainWnd, NULL, NULL, (void*)DIVIDER_VERTICAL);
		HWND dv2 = CreateWindowEx(0, WC_DIVIDER, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, dv, NULL, NULL, (void*)DIVIDER_HORIZONTAL);
		HWND dv3 = CreateWindowEx(0, WC_DIVIDER, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, dv2, NULL, NULL, (void*)DIVIDER_HORIZONTAL);

		// List Pane
		HWND d1 = CreateWindowEx(WS_EX_CLIENTEDGE, WC_TOOLIST, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, dv, NULL, NULL, hMainWnd);
		// Condition Pane
		HWND d2 = CreateWindowEx(WS_EX_CLIENTEDGE, WC_TOOLIST, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, dv2, NULL, NULL, hMainWnd);
		// Exclude Pane
		HWND d3 = CreateWindowEx(WS_EX_CLIENTEDGE, WC_TOOLIST, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, dv3, NULL, NULL, hMainWnd);
		// Preview Pane
		HWND d4 = CreateWindowEx(WS_EX_CLIENTEDGE, WC_PIKTURE, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, dv3, NULL, NULL, NULL);

		Divider_SetWindow(dv3, 0, d3);
		Divider_SetWindow(dv3, 1, d4);

		Divider_SetWindow(dv2, 0, d2);
		Divider_SetWindow(dv2, 1, dv3);

		Divider_SetWindow(dv, 0, dv2);
		Divider_SetWindow(dv, 1, d1);

		// ListPane Toolbar
		{
			TBBUTTON tb = {0};
			HWND twnd = Toolist_GetToolbar(d1);//(HWND)SendMessage(d1, WM_USER, 0, 0);

			tb.idCommand = ID_FINDSTART;
			tb.iBitmap = 3;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_FINDSTOP;
			if(GetAsyncKeyState(VK_SHIFT) & 0x8000)	// EasterEgg
				tb.iBitmap = 10;
			else
				tb.iBitmap = 4;
			tb.fsState = /*TBSTATE_ENABLED*/0;
			tb.fsStyle = TBSTYLE_BUTTON;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_CHECKSTATE;
			tb.iBitmap = 7;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_FILECOPY;
			tb.iBitmap = 5;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_FILEMOVE;
			tb.iBitmap = 6;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_FILETRASH;
			tb.iBitmap = 12;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_SETWALLPAPER;
			tb.iBitmap = 13;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			// stub: PreviewSize

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_SETTINGS;
			tb.iBitmap = 9;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_HELPME;
			tb.iBitmap = 8;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			SendMessage(twnd, TB_AUTOSIZE, 0, 0);
		}
		// ListPane ListView
		{
			LV_COLUMN lvc;
			HWND lwnd = Toolist_GetListview(d1);//(HWND)SendMessage(d1, WM_USER, 1, 0);
			//LV_ITEM lvi;

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_FILENAME);
			lvc.cx = 200;
			ListView_InsertColumn(lwnd, 0, &lvc);

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_PICSIZE);
			lvc.cx = 100;
			ListView_InsertColumn(lwnd, 1, &lvc);

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_FILESIZE);
			lvc.cx = 100;
			ListView_InsertColumn(lwnd, 2, &lvc);

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_PATH);
			lvc.cx = 100;
			ListView_InsertColumn(lwnd, 3, &lvc);

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_HANDLEDBY);
			lvc.cx = 100;
			ListView_InsertColumn(lwnd, 4, &lvc);
		}

		// ConditionPane Toolbar
		{
			TBBUTTON tb = {0};
			HWND twnd = Toolist_GetToolbar(d2);//(HWND)SendMessage(d2, WM_USER, 0, 0);

			tb.idCommand = ID_ADDCONDITION;
			tb.iBitmap = 0;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_REMOVECONDITION;
			tb.iBitmap = 1;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_SETCONDITION;
			tb.iBitmap = 2;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON | TBSTYLE_DROPDOWN;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			// stub: Size&Condition

			SendMessage(twnd, TB_AUTOSIZE, 0, 0);
		}
		// ConditionPane ListView
		{
			LV_COLUMN lvc;
			HWND lwnd = Toolist_GetListview(d2);//(HWND)SendMessage(d2, WM_USER, 1, 0);

			// wb_܂
			SetWindowLong(lwnd, GWL_STYLE, GetWindowLong(lwnd, GWL_STYLE) | LVS_NOSORTHEADER);
			SetWindowLong(ListView_GetHeader(lwnd), GWL_STYLE, GetWindowLong(ListView_GetHeader(lwnd), GWL_STYLE) & ~HDS_BUTTONS);
			// `FbN{bNXȂ
			ListView_SetExtendedListViewStyle(lwnd, ListView_GetExtendedListViewStyle(lwnd) & ~LVS_EX_CHECKBOXES);

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_PICSIZE);
			lvc.cx = 100;
			ListView_InsertColumn(lwnd, 0, &lvc);

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_CONDITION);
			lvc.cx = 50;
			ListView_InsertColumn(lwnd, 1, &lvc);
		}

		// ExcludePane Toolbar
		{
			TBBUTTON tb = {0};
			HWND twnd = Toolist_GetToolbar(d3);//(HWND)SendMessage(d3, WM_USER, 0, 0);

			tb.idCommand = ID_ADDEXCLUDE;
			tb.iBitmap = 0;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = ID_REMOVEEXCLUDE;
			tb.iBitmap = 1;
			tb.fsState = TBSTATE_ENABLED;
			tb.fsStyle = TBSTYLE_BUTTON;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			tb.idCommand = 0;
			tb.iBitmap = 0;
			tb.fsStyle = TBSTYLE_SEP;
			SendMessage(twnd, TB_ADDBUTTONS, 1, (LPARAM)&tb);

			// stub: Path

			SendMessage(twnd, TB_AUTOSIZE, 0, 0);
		}
		// ExcludePane ListView
		{
			LV_COLUMN lvc;
			HWND lwnd = Toolist_GetListview(d3);//(HWND)SendMessage(d3, WM_USER, 1, 0);

			// wb_܂
			SetWindowLong(lwnd, GWL_STYLE, GetWindowLong(lwnd, GWL_STYLE) | LVS_NOSORTHEADER);
			SetWindowLong(ListView_GetHeader(lwnd), GWL_STYLE, GetWindowLong(ListView_GetHeader(lwnd), GWL_STYLE) & ~HDS_BUTTONS);
			// `FbN{bNXȂ
			ListView_SetExtendedListViewStyle(lwnd, ListView_GetExtendedListViewStyle(lwnd) & ~LVS_EX_CHECKBOXES);

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.pszText = String(IDS_EXCLUDEPATH);
			lvc.cx = 150;
			ListView_InsertColumn(lwnd, 0, &lvc);
		}

		mwv->hDividerWnd = dv;
	}
	// StatusBar
	{
		HWND sb = CreateWindowEx(0, STATUSCLASSNAME, NULL, WS_VISIBLE | WS_CHILD, 0, 0, 0, 0, hMainWnd, NULL, GetModuleHandle(NULL), NULL);

		SendMessage(sb, SB_SETTEXT, 0 | 0, (LPARAM)TEXT("Welcome to scooper"));

		mwv->hStatusWnd = sb;
	}

	return;
}

struct findStartStruct{
	HWND hWnd;
	LPTSTR path;
	BOOL recurse;
};
void EnableToolbarButtons(HWND hWnd, BOOL enable)
{
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
	HWND hToolbar = Toolist_GetToolbar(Divider_GetWindow(mwv->hDividerWnd, 1));

	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_FINDSTART, MAKELPARAM(enable, 0));
	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_FINDSTOP, MAKELPARAM(!enable, 0));	// STOP͔΁B
	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_FILECOPY, MAKELPARAM(enable, 0));
	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_FILEMOVE, MAKELPARAM(enable, 0));
	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_FILETRASH, MAKELPARAM(enable, 0));
	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_SETWALLPAPER, MAKELPARAM(enable, 0));
	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_CHECKSTATE, MAKELPARAM(enable, 0));
	SendMessage(hToolbar, TB_ENABLEBUTTON, ID_SETTINGS, MAKELPARAM(enable, 0));

	return;
}
void EnableForms(HWND hWnd, BOOL enable)
{
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);

	// CondPane
	{
		HWND hToolbar = Toolist_GetToolbar(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));
		HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));

		SendMessage(hToolbar, TB_ENABLEBUTTON, ID_ADDCONDITION, MAKELPARAM(enable, 0));
		SendMessage(hToolbar, TB_ENABLEBUTTON, ID_REMOVECONDITION, MAKELPARAM(enable, 0));
		SendMessage(hToolbar, TB_ENABLEBUTTON, ID_SETCONDITION, MAKELPARAM(enable, 0));

		EnableWindow(hListWnd, enable);
	}

	// ExcludePane
	{
		HWND hToolbar = Toolist_GetToolbar(Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 0));
		HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 0));

		SendMessage(hToolbar, TB_ENABLEBUTTON, ID_ADDEXCLUDE, MAKELPARAM(enable, 0));
		SendMessage(hToolbar, TB_ENABLEBUTTON, ID_REMOVEEXCLUDE, MAKELPARAM(enable, 0));

		EnableWindow(hListWnd, enable);
	}

	// ListPane
	EnableToolbarButtons(hWnd, enable);

	return;
}
DWORD WINAPI findThread(LPVOID fss)
{
	HWND hWnd = ((struct findStartStruct*)fss)->hWnd;
	LPTSTR path = ((struct findStartStruct*)fss)->path;
	BOOL recurse = ((struct findStartStruct*)fss)->recurse;
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);

	TCHAR cdir[MAX_PATH];

	hfree(fss);	//ł܂

	// disable all toolbar item
	EnableForms(hWnd, FALSE);
	// disable list
	EnableWindow(Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1)), FALSE);

	GetCurrentDirectory(sizeof(cdir), cdir);
	SetCurrentDirectory(path);
	// Xg𑗂(hMainWnd->Divider->Ê->List)
	SendMessage(mwv->hStatusWnd, SB_SIMPLE, TRUE, 0);
	ListView_DeleteAllItems((HWND)SendMessage((HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, 1, 0));
	{
		HWND hListWnd = (HWND)SendMessage((HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, 1, 0);
		HWND hCondListWnd = (HWND)SendMessage(/*ConditionToolist->*/(HWND)SendMessage(/*LeftDivider->*/(HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(0, 1), 0), WM_USER, MAKEWPARAM(0, 1), 0), WM_USER, 1, 0);
		HWND hExcludeListWnd = (HWND)SendMessage(/*ExcludeToolist->*/(HWND)SendMessage(/*LeftDivider2->*/(HWND)SendMessage(/*LeftDivider->*/(HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(0, 1), 0), WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, MAKEWPARAM(0, 1), 0), WM_USER, 1, 0);

		UINT files = 0;
		UINT tsize = 0;

		recurseSearcher(hListWnd, mwv->hStatusWnd, hCondListWnd, hExcludeListWnd, hWnd, &files, &tsize, recurse);

		if(!files)
		{	// t@C
			SendMessage(mwv->hStatusWnd, SB_SETTEXT, 0 | 0, (LPARAM)String(IDS_NOITEMFOUND));
		}else
		{	// t@C
			TCHAR ts[256];

			wsprintf(ts, String(IDS_FOUNDSTATUS), files, tsize);
			SendMessage(mwv->hStatusWnd, SB_SETTEXT, 0 | 0, (LPARAM)ts);
		}
	}
	SendMessage(mwv->hStatusWnd, SB_SIMPLE, FALSE, 0);
	SetCurrentDirectory(cdir);

	// enable  all toolbar item
	EnableForms(hWnd, TRUE);
	// enable list
	EnableWindow(Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1)), TRUE);

	//hfree(path);	// <s>p</s>Ɏg

	mwv->tidFind = 0;	// I(FindThreadThreadID0)

	return 0;
}

void findStart(HWND hWnd, LPTSTR dir, BOOL recurse)
{
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
	struct findStartStruct* fss;

	// ConditionList`FbN
	{
		HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));

		if(!ListView_GetItemCount(hListWnd))
		{
			MessageBox(hWnd, String(IDS_NOCONDITIONSTOFIND), String(IDS_ERROR), MB_ICONERROR | MB_OK);
			return;
		}
	}

	fss = halloc(sizeof(struct findStartStruct));

	fss->hWnd = hWnd;
	fss->path = dir;
	fss->recurse = recurse;

	CreateThread(NULL, 0, findThread, fss, 0, &mwv->tidFind);

	return;
}

struct fopStartStruct{
	HWND hWnd;
	LPTSTR path;
	BOOL useTrash;
	UINT fop;
};
DWORD WINAPI fopThread(LPVOID fops)
{
	HWND hWnd = ((struct fopStartStruct*)fops)->hWnd;
	LPTSTR path = ((struct fopStartStruct*)fops)->path;
	UINT foperation = ((struct fopStartStruct*)fops)->fop;
	UINT useTrash = ((struct fopStartStruct*)fops)->useTrash;
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);

	TCHAR cdir[MAX_PATH];

	hfree(fops);	//ł܂

	// disable all toolbar item
	EnableToolbarButtons(hWnd, FALSE);
	// disable list
	EnableWindow(Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1)), FALSE);

	GetCurrentDirectory(sizeof(cdir), cdir);
	if(path)	// FO_DELETȄꍇpathNULLłB
	{
		cutEndYen(path);
		if(!SetCurrentDirectory(path))
		{
			if(MessageBox(NULL, String(IDS_FOPDESTNOTFOUND), String(IDS_CONFIRM), MB_ICONQUESTION | MB_YESNO) == IDNO)
				goto endf;
			if(!makedir(path))
			{
				MessageBox(NULL, String(IDS_CANTMAKEFOPDEST), String(IDS_ERROR), MB_ICONERROR | MB_OK);
				goto endf;
			}
		}
	}
	// Xg𑗂(hMainWnd->Divider->Ê->List)
	SendMessage(mwv->hStatusWnd, SB_SIMPLE, TRUE, 0);
	//ListView_DeleteAllItems((HWND)SendMessage((HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, 1, 0));
	{
		HWND hListWnd = (HWND)SendMessage((HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, 1, 0);
		int max = ListView_GetItemCount(hListWnd), i;

		// stub: Rs[

		for(i = 0; i < max; i++)
		{
			if(ListView_GetCheckState(hListWnd, i))
			{
				TCHAR pictf[MAX_PATH];

				ListView_GetItemText(hListWnd, i, 3, pictf, sizeof(pictf));
				addEndYen(pictf);
				ListView_GetItemText(hListWnd, i, 0, pictf + lstrlen(pictf), sizeof(pictf) - lstrlen(pictf));
				pictf[lstrlen(pictf) + 1] = '\0';	// DoubleNullTerminated!!

				//MessageBox(NULL, path, pictf, 0);
				// Do Copy!
				if(foperation == FO_COPY || foperation == FO_MOVE)
				{
					SHFILEOPSTRUCT fop;
					TCHAR tofile[MAX_PATH];

					fop.hwnd = hWnd;
					fop.wFunc = foperation;
					fop.pFrom = pictf;
					fop.pTo = path;
					fop.fFlags = FOF_ALLOWUNDO;
					fop.hNameMappings = NULL;
					fop.lpszProgressTitle = NULL;

					// ݊mF
					lstrcpy(tofile, path);
					lstrcat(tofile, TEXT("\\"));	// cutEndYen(path)ĂB
					lstrcat(tofile, basename(pictf));

					if(GetFileAttributes(tofile) != 0xFFFFFFFF)
					{	// !!
						switch(Option.HowtoWhenAlreadyExist)
						{
						case FOP_RENAME:
							{
								TCHAR ext[16];
								LPTSTR last;
								UINT i;

								last = (LPTSTR)lastchar(tofile, TEXT('.'));
								lstrcpy(ext, last);

								for(i = 1; i < 0xFFFFFFFF; i++)	// 32bit߂Ⴄ[!!
								{
									wsprintf(last, TEXT("(%u)%s"), i, ext);
									if(GetFileAttributes(tofile) == 0xFFFFFFFF)
									{
										// Oς悤
										fop.pTo = tofile;
										break;
									}
								}
							}
							break;
						case FOP_OVERWRITE:
							// mFȂB
							fop.fFlags |= FOF_NOCONFIRMATION;
							break;
						case FOP_THROUGH:
							continue;	// forcontinue
						}
					}

					if(SHFileOperation(&fop))	// 0Ɛ= !0Ǝs...?
					{
						if(MessageBox(hWnd, TEXT("SHFileOperation(FO_COPY/FO_MOVE) Failed!!\ncontinue?"), String(IDS_ERROR), MB_ICONERROR | MB_YESNO) == IDNO)
							break;
					}else
					{
						if(foperation == FO_COPY)
						{
							if(Option.UncheckWhenFOPSuccessful)
								ListView_SetCheckState(hListWnd, i, FALSE);
						}
						if(foperation == FO_MOVE)
						{
							ListView_DeleteItem(hListWnd, i);
							i--;
							max--;
						}
					}
				}
				if(foperation == FO_DELETE)
				{
					if(useTrash)
					{
						SHFILEOPSTRUCT fop;

						fop.hwnd = hWnd;
						fop.wFunc = foperation;
						fop.pFrom = pictf;
						fop.fFlags = FOF_ALLOWUNDO | FOF_NOCONFIRMATION;
						fop.hNameMappings = NULL;
						fop.lpszProgressTitle = NULL;

						if(SHFileOperation(&fop))	// 0Ɛ= !0Ǝs...?
						{
							if(MessageBox(hWnd, TEXT("SHFileOperation(FO_DELETE) Failed!!\nContinue?"), String(IDS_ERROR), MB_ICONERROR | MB_YESNO) == IDNO)
								break;
						}else
						{
							ListView_DeleteItem(hListWnd, i);
							i--;
							max--;
						}
					}else
					{
						if(!DeleteFile(pictf))
						{
							if(MessageBox(hWnd, TEXT("DeleteFile Failed!!\nContinue?"), String(IDS_ERROR), MB_ICONERROR | MB_OK) == IDNO)
								break;
						}else
						{
							ListView_DeleteItem(hListWnd, i);
							i--;
							max--;
						}
					}
				}
			}
		}
	}
endf:
	SendMessage(mwv->hStatusWnd, SB_SIMPLE, FALSE, 0);
	SetCurrentDirectory(cdir);

	// enable  all toolbar item
	EnableToolbarButtons(hWnd, TRUE);
	// enable list
	EnableWindow(Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1)), TRUE);

	mwv->tidFind = 0;	// I(FindThreadThreadID0)

	return 0;
}

void copyStart(HWND hWnd, LPTSTR dir)
{
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
	struct fopStartStruct* fops;

	{
		TCHAR msg[1024];
		HWND hListWnd = (HWND)SendMessage((HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, 1, 0);
		int num = 0, max = ListView_GetItemCount(hListWnd), i;

		for(i = 0; i < max; i++)
		{
			if(ListView_GetCheckState(hListWnd, i))
				num++;
		}

		// TODO: `FbNĂȂIĂ̂Ώۂɂ悢?
		if(num == 0)
		{
			MessageBox(hWnd, String(IDS_NOFILESELECTED), String(IDS_ERROR), MB_ICONERROR | MB_OK);
		}else
		{
			wsprintf(msg, String(IDS_CONFIRMFILECOPY), num, dir);

			if(MessageBox(hWnd, msg, String(IDS_CONFIRM), MB_ICONQUESTION | MB_YESNO) == IDYES)
			{
				fops = halloc(sizeof(struct fopStartStruct));

				fops->hWnd = hWnd;
				fops->path = dir;
				fops->fop = FO_COPY;

				CreateThread(NULL, 0, fopThread, fops, 0, &mwv->tidFind);
			}
		}
	}

	return;
}

void moveStart(HWND hWnd, LPTSTR dir)
{
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
	struct fopStartStruct* fops;

	{
		TCHAR msg[1024];
		HWND hListWnd = (HWND)SendMessage((HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, 1, 0);
		int num = 0, max = ListView_GetItemCount(hListWnd), i;

		for(i = 0; i < max; i++)
		{
			if(ListView_GetCheckState(hListWnd, i))
				num++;
		}

		if(num == 0)
		{
			MessageBox(hWnd, String(IDS_NOFILESELECTED), String(IDS_ERROR), MB_ICONERROR | MB_OK);
		}else
		{
			wsprintf(msg, String(IDS_CONFIRMFILEMOVE), num, dir);

			if(MessageBox(hWnd, msg, String(IDS_CONFIRM), MB_ICONQUESTION | MB_YESNO) == IDYES)
			{
				fops = halloc(sizeof(struct fopStartStruct));

				fops->hWnd = hWnd;
				fops->path = dir;
				fops->fop = FO_MOVE;

				CreateThread(NULL, 0, fopThread, fops, 0, &mwv->tidFind);
			}
		}
	}

	return;
}

void deleteStart(HWND hWnd, BOOL useTrash)
{
	struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
	struct fopStartStruct* fops;

	{
		TCHAR msg[1024];
		HWND hListWnd = (HWND)SendMessage((HWND)SendMessage(mwv->hDividerWnd, WM_USER, MAKEWPARAM(1, 1), 0), WM_USER, 1, 0);
		int num = 0, max = ListView_GetItemCount(hListWnd), i;

		for(i = 0; i < max; i++)
		{
			if(ListView_GetCheckState(hListWnd, i))
				num++;
		}

		if(num == 0)
		{
			MessageBox(hWnd, String(IDS_NOFILESELECTED), String(IDS_ERROR), MB_ICONERROR | MB_OK);
		}else
		{
			if(useTrash)
				wsprintf(msg, String(IDS_CONFIRMFILETRASH), num);
			else
				wsprintf(msg, String(IDS_CONFIRMFILEDELETE), num);

			if(MessageBox(hWnd, msg, (useTrash ? String(IDS_CONFIRM) : String(IDS_WARNING)), (useTrash ? MB_ICONQUESTION : MB_ICONWARNING) | MB_YESNO) == IDYES)
			{
				fops = halloc(sizeof(struct fopStartStruct));

				fops->hWnd = hWnd;
				fops->path = NULL;
				fops->useTrash = useTrash;
				fops->fop = FO_DELETE;

				CreateThread(NULL, 0, fopThread, fops, 0, &mwv->tidFind);
			}
		}
	}

	return;
}

void SaveConfig(BOOL last);

struct tagFileListSortVal{
	HWND hListWnd;
	int iCol;
};

int CALLBACK FileListSortCallback(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	LV_FINDINFO lvf;
	struct tagFileListSortVal* flsv = (struct tagFileListSortVal*)lParamSort;
	DWORD nItem1, nItem2;
	TCHAR buf1[30], buf2[30];
	DWORD uParam = Toolist_GetListColumnStatus(flsv->hListWnd);

	lvf.flags = LVFI_PARAM;

	lvf.lParam = lParam1;
	nItem1 = ListView_FindItem(flsv->hListWnd, -1, &lvf);

	lvf.lParam = lParam2;
	nItem2 = ListView_FindItem(flsv->hListWnd, -1, &lvf);

	if(uParam == 0xFFFF0000)
	{
		LPARAM li1, li2;
		LV_ITEM lvi;

		lvi.mask = LVIF_PARAM;

		lvi.iItem = nItem1;
		ListView_GetItem(flsv->hListWnd, &lvi);
		li1 = lvi.lParam;

		lvi.iItem = nItem2;
		ListView_GetItem(flsv->hListWnd, &lvi);
		li2 = lvi.lParam;

		return (li1 < li2) ? -1 : ((li1 > li2) ? 1 : 0);
	}

	switch(flsv->iCol)
	{
	case 0:	// FileName
	case 3:	// FullPath
	case 4:	// HandledBy
		ListView_GetItemText(flsv->hListWnd, nItem1, flsv->iCol, buf1, sizeof(buf1));
		ListView_GetItemText(flsv->hListWnd, nItem2, flsv->iCol, buf2, sizeof(buf2));

		return(LOWORD(uParam) ? lstrcmp(buf1, buf2) * -1 : lstrcmp(buf1, buf2));
	case 1:	// PictSize
		// TODO: fŃ\[g낤?;
		return 0;
	case 2:	// FileSize
		ListView_GetItemText(flsv->hListWnd, nItem1, flsv->iCol, buf1, sizeof(buf1));
		ListView_GetItemText(flsv->hListWnd, nItem2, flsv->iCol, buf2, sizeof(buf2));

		nItem1 = strToDword(buf1);
		nItem2 = strToDword(buf2);

		return LOWORD(uParam) ? (((nItem1 < nItem2) ? -1 : ((nItem1 > nItem2) ? 1 : 0)) * -1) : ((nItem1 < nItem2) ? -1 : ((nItem1 > nItem2) ? 1 : 0));
	}

	return 0;
}

BOOL SetWallpaper(LPCTSTR fname, UINT mode/*ȉ{͂Ȃq*/, HWND hWnd)
{
	HKEY hk;

	if(RegOpenKeyEx(HKEY_CURRENT_USER, TEXT("Control Panel\\Desktop"), 0, KEY_WRITE, &hk))
	{
		MessageBox(hWnd, TEXT("RegOpenKeyEx failed"), String(IDS_ERROR), MB_ICONERROR | MB_OK);
	}else
	{
		OSVERSIONINFO osvi;

		osvi.dwOSVersionInfoSize = sizeof(osvi);
		if(!GetVersionEx(&osvi))
		{
			// !? GetVersionEx failed !?
		}else
		{
			// OSVersion vs wallpaper
			//  == ONLY TileWallpaper support ==
			//  Win95	: 0400
			//  WinNT4	: 0400
			//  == WallpaperStyle support ==
			//  Win98	: 040A
			//  WinMe	: ?
			//  Win2000	: 0500
			//  == ConvertedWallpaper support ==
			//  WinXP	: 0501
			//  == ??? ==
			//  WinVista: ?

			switch(mode)
			{
			case 0:
				RegSetValueEx(hk, TEXT("TileWallpaper"), 0, REG_SZ, TEXT("0"), sizeof(TEXT("0")));
				if(((osvi.dwMajorVersion << 8) | osvi.dwMinorVersion) >= 0x040A)
					RegSetValueEx(hk, TEXT("WallpaperStyle"), 0, REG_SZ, TEXT("0"), sizeof(TEXT("0")));
				break;
			case 1:
				RegSetValueEx(hk, TEXT("TileWallpaper"), 0, REG_SZ, TEXT("1"), sizeof(TEXT("1")));
				if(((osvi.dwMajorVersion << 8) | osvi.dwMinorVersion) >= 0x040A)
					RegSetValueEx(hk, TEXT("WallpaperStyle"), 0, REG_SZ, TEXT("0"), sizeof(TEXT("0")));
				break;
			case 2:
				RegSetValueEx(hk, TEXT("TileWallpaper"), 0, REG_SZ, TEXT("0"), sizeof(TEXT("0")));
				if(((osvi.dwMajorVersion << 8) | osvi.dwMinorVersion) >= 0x040A)
					RegSetValueEx(hk, TEXT("WallpaperStyle"), 0, REG_SZ, TEXT("2"), sizeof(TEXT("2")));
				break;
			}

			/*
			// for DEBUG
			{
				TCHAR ts[32];

				wsprintf(ts, TEXT("OSV: %04X"), ((osvi.dwMajorVersion << 8) | osvi.dwMinorVersion));
				MessageBox(NULL, ts, NULL, 0);
			}
			*/

			if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT && ((osvi.dwMajorVersion << 8) | osvi.dwMinorVersion) >= 0x0501)
				RegSetValueEx(hk, TEXT("ConvertedWallpaper"), 0, REG_SZ, fname, lstrlen(fname));
		}

		RegCloseKey(hk);
	}

	if(!fname)
	{	// fname==NULL: Set None
		SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, TEXT(""), SPIF_UPDATEINIFILE | SPIF_SENDCHANGE);
	}else
	{	// fname!=NULL: Set fname
		ITEMIDLIST* idl = NULL;
		TCHAR path[MAX_PATH];

		if(!SHGetSpecialFolderLocation(hWnd, CSIDL_LOCAL_APPDATA, &idl))
		{	// idl->path
			SHGetPathFromIDList(idl, path);
			CoTaskMemFree(idl);

			addEndYen(path);
			lstrcat(path, TEXT("Microsoft\\"));
		}else
		if(GetTempPath(sizeof(path), path))
		{	// GetTemPath succeed
			addEndYen(path);
		}else
		{	// GetTempPath ERROR!!
			GetModuleFileName(NULL, path, sizeof(path));
			*(LPTSTR)basename(path) = '\0';

			addEndYen(path);	// need?
		}

		// Is it right?
		{	// NoError
			HBITMAP hbm;

			// for DEBUG
			//if(MessageBox(hWnd, path, NULL, MB_YESNO) == IDNO)
			//	return FALSE;

			lstrcat(path, TEXT("Wallpaper1.bmp"));

			// getpicture->save
			if(hbm = spiGetPicture(fname))
			{
				HDC hdc;
				BITMAPINFO bmi = {0};	// GetDIBits̗Ƃ1

				hdc = GetDC(hWnd);

				bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);	// GetDIBits̗Ƃ2
				if(GetDIBits(hdc, hbm, 0, 1, NULL, &bmi, DIB_RGB_COLORS))
				{	// SAVE TO BMP!
					/*
						ȉ̃y[WQlɂ܂B

						charbg}bvt@Cɕۑ
						http://www.sm.rim.or.jp/~shishido/savebmp.html

						256Ή߂ǂɂB
					*/
					BITMAPFILEHEADER bf;
					BYTE* pixels;
					DWORD pixelbytes = 0;
					HANDLE hf;
					BITMAPINFO* bi;
					DWORD bisize;
					UINT colors;

					// Win98΍
					//colors = bmi.bmiHeader.biClrUsed;
					colors = 0;
					if(bmi.bmiHeader.biBitCount <= 8)
					{
						UINT i = bmi.bmiHeader.biBitCount;

						colors = 2;

						while(--i)
						{
							colors <<= 1;
						}
					}

					bisize = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * colors;
					bi = halloc(bisize);
					FillByZero(bi, bisize);

					// n + (m - 1) / m = cut up
					// n / m           = cut down
					pixelbytes = bmi.bmiHeader.biSizeImage;//(((bmi.bmiHeader.biWidth * bmi.bmiHeader.biBitCount / 8) * 4 + 3) / 4) * bmi.bmiHeader.biHeight;

					// set headers
					bf.bfType = ('M' << 8) | 'B';
					bf.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + pixelbytes;
					bf.bfReserved1 = 0;
					bf.bfReserved2 = 0;
					bf.bfOffBits = sizeof(BITMAPFILEHEADER) + bisize;

					// get pixels
					pixels = halloc(pixelbytes);

					// bi->bmiHeader̍ŏ6ݒ肷邭炢ȂSRs[B
					*(BITMAPINFOHEADER*)bi = bmi.bmiHeader;

					//bmi.bmiColors = NULL;
					if(!GetDIBits(hdc, hbm, 0, bmi.bmiHeader.biHeight, pixels, bi, DIB_RGB_COLORS))
					{
						MessageBox(hWnd, TEXT("GetDIBits(2) failed"), String(IDS_ERROR), MB_ICONERROR | MB_OK);
					}

					// write!
					if((hf = CreateFile(path, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE)
					{
						MessageBox(hWnd, String(IDS_CANTOPENTOWRITEWP), String(IDS_ERROR), MB_ICONERROR | MB_OK);
					}else
					{
						DWORD written;

						// Ô
						SetFilePointer(hf, 0, NULL, FILE_BEGIN);

						if(!WriteFile(hf, &bf, sizeof(bf), &written, NULL) || written < sizeof(bf))
							MessageBox(hWnd, String(IDS_CANTWRITEBMFH), String(IDS_ERROR), MB_ICONERROR | MB_OK);
						if(!WriteFile(hf, bi, bisize, &written, NULL) || written < bisize)
							MessageBox(hWnd, String(IDS_CANTWRITEBMIH), String(IDS_ERROR), MB_ICONERROR | MB_OK);
						if(!WriteFile(hf, pixels, pixelbytes, &written, NULL) || written < (int)pixelbytes)
							MessageBox(hWnd, String(IDS_CANTWRITEBMPX), String(IDS_ERROR), MB_ICONERROR | MB_OK);

						CloseHandle(hf);

						SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, path, SPIF_UPDATEINIFILE | SPIF_SENDCHANGE);
					}

					DeleteObject(hbm);
				}

				ReleaseDC(hWnd, hdc);
			}
		}
	}

	//SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, pictf, SPIF_UPDATEINIFILE | SPIF_SENDCHANGE);
	return TRUE;
}

BOOL addChaindir(Chaindir** root, LPTSTR path, BOOL recurse)
{
	Chaindir* cd;

	{
		LPTSTR dir = lstrlwr(lstrdupplus(path, 1));

		addEndYen(dir);

		for(cd = *root; cd; cd = cd->next)
		{
			LPTSTR indir = lstrlwr(lstrdupplus(cd->dir, 1));

			addEndYen(indir);

			if(!lstrcmp(dir, indir))
			{
				hfree(indir);
				hfree(dir);

				return FALSE;
			}

			hfree(indir);
		}

		hfree(dir);
	}

	cd = halloc(sizeof(Chaindir));

	cd->dir = path;
	cd->recurse = recurse;
	cd->next = *root;

	*root = cd;

	return TRUE;
}

BOOL addConditionset(HWND hListWnd, LPTSTR name)
{
	ConditionSet* cs, *pcs = NULL;

	for(cs = CondSetroot; cs; pcs = cs, cs = cs->next)
	{
		if(!lstrcmp(cs->name, name))
			break;
	}

	if(!cs)
	{
		cs = halloc(sizeof(ConditionSet));
		cs->name = name;
		cs->next = CondSetroot;
	}else
	{
		// freeing items
		UINT i;

		for(i = 0; i < cs->itemcount; i++)
			hfree(cs->items[i]);
		hfree(cs->items);

		if(!pcs)
			CondSetroot = cs->next;
		else
			pcs->next = cs->next;
		cs->next = CondSetroot;
	}

	cs->itemcount = ListView_GetItemCount(hListWnd);
	cs->items = halloc(sizeof(ConditionItem*) * cs->itemcount);

	{
		LV_ITEM lvi;

		lvi.mask = LVIF_PARAM;
		lvi.iSubItem = 0;

		for(lvi.iItem = 0; lvi.iItem < (int)cs->itemcount; lvi.iItem++)
		{
			ConditionItem* ci;

			ci = halloc(sizeof(ConditionItem));
			ListView_GetItem(hListWnd, &lvi);
			*ci = *(ConditionItem*)lvi.lParam;

			cs->items[lvi.iItem] = ci;	// Rs[̂́uXĝ͍폜v\邽
		}
	}

	CondSetroot = cs;

	return TRUE;
}


LPITEMIDLIST GetItemIDList(HWND hWnd, LPSHELLFOLDER pShellFolder, LPCTSTR lpszPath)
{
	LPITEMIDLIST pIDList = NULL;

	OLECHAR* ochPath;
	ULONG chLen = 0;
	ULONG dwAttributes = 0;
	//ochPath = T2OLE( const_cast< LPTSTR >( lpszPath ) );

	ochPath = halloc((lstrlen(lpszPath) + 1) * 2);
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, lpszPath, /*lstrlen(lpszPath)*/-1,  ochPath, (lstrlen(lpszPath) + 1) * 2);

	if( pShellFolder->lpVtbl->ParseDisplayName( pShellFolder, hWnd, NULL, ochPath, &chLen, &pIDList, &dwAttributes ) != NOERROR ){
		return NULL;
	}

	hfree(ochPath);

	return pIDList;
}


LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE:
		{
			struct tagMainWndVal* mwv;

			// TODO: G[
			SetWindowLong(hWnd, 0, (LONG)(mwv = halloc(sizeof(struct tagMainWndVal))));

			makeMainForm(hWnd);
			mwv->tidFind = 0;
			mwv->cm2 = NULL;
		}
		break;
	case WM_DESTROY:
		break;

	case WM_SIZE:
		{
			struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
			RECT rc;

			SendMessage(mwv->hStatusWnd, WM_SIZE, wParam, lParam);
			GetClientRect(mwv->hStatusWnd, &rc);
			SetWindowPos(mwv->hDividerWnd, NULL, 0, 0, LOWORD(lParam), HIWORD(lParam) - rc.bottom, SWP_NOZORDER);
		}
		break;
	case WM_CLOSE:
		// ConditionPane List(lParam[Nh~A܂OSĂ邯)
		{
			struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
			HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));

			ListView_DeleteAllItems(hListWnd);
		}

		PostQuitMessage(0);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
			// ConditionPane
		case ID_ADDCONDITION:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));
				struct tagAddconditionDlgVal* adv = halloc(sizeof(struct tagAddconditionDlgVal));

				adv->hListWnd = hListWnd;
				adv->id = -1;

				DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ADDCONDITION), hWnd, AddconditionDlgProc, (LPARAM)adv);

				// ^Cgo[
				RedrawWindow(hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW);
			}
			break;
		case ID_REMOVECONDITION:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));
				int idx;

				while((idx = ListView_GetNextItem(hListWnd, -1, LVNI_ALL | LVNI_SELECTED)) != -1)
				{
					ListView_DeleteItem(hListWnd, idx);
				}
			}
			break;
		case ID_SETCONDITION:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));

				if(!CondSetroot)
				{	// ۑ
					LPTSTR name;

					if(!ListView_GetItemCount(hListWnd))
					{
						MessageBox(hWnd, String(IDS_NOCONDITIONSTOSAVE), String(IDS_ERROR), MB_ICONERROR | MB_OK);
						break;
					}

					if(!(name = (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_SAVECOND), hWnd, savecondDlgProc, (LPARAM)hListWnd)))
					{
						// LZꂽ
						break;
					}

					addConditionset(hListWnd, name);
				}else
				{	// [h
					int i;

					ListView_DeleteAllItems(hListWnd);
					for(i = 0; i < (int)CondSetroot->itemcount; i++)
					{
						LV_ITEM lvi;
						TCHAR ts[32];

						lvi.mask = LVIF_TEXT | LVIF_PARAM;
						lvi.iItem = ListView_GetItemCount(hListWnd);
						lvi.iSubItem = 0;
						{
							ConditionItem* ci;

							ci = halloc(sizeof(ConditionItem));

							*ci = *CondSetroot->items[i];

							lvi.lParam = (LPARAM)ci;

							wsprintf(ts, TEXT("%d x %d"), ci->width, ci->height);
							lvi.pszText = ts;

							ListView_InsertItem(hListWnd, &lvi);

							ListView_SetItemText(hListWnd, lvi.iItem, 1, (LPTSTR)ConditionTextList[ci->cond]);
						}
					}
				}
			}
			break;
			// ExculdePane:
		case ID_ADDEXCLUDE:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 0));
				struct tagAddexcludeDlgVal* edv = halloc(sizeof(struct tagAddexcludeDlgVal));

				edv->hListWnd = hListWnd;
				edv->id = -1;

				DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ADDEXCLUDE), hWnd, AddexcludeDlgProc, (LPARAM)edv);

				// ^Cgo[
				RedrawWindow(hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW);
			}
			break;
		case ID_REMOVEEXCLUDE:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 0));
				int idx;

				while((idx = ListView_GetNextItem(hListWnd, -1, LVNI_ALL | LVNI_SELECTED)) != -1)
				{
					ListView_DeleteItem(hListWnd, idx);
				}
			}
			break;
			// ListPane
		case ID_FINDSTART:
			if(!Option.TBFindAlwaysAsk && Option.recentScandir)
				findStart(hWnd, Option.recentScandir->dir, Option.recentScandir->recurse);
			else
			{
				// TODO: ɂ܂Ƃ߂
				LPTSTR dir;
				BOOL recurse;

				if(!(dir = (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_REFERDIRECTORY), hWnd, DirreferDlgProc, (LPARAM)String(IDS_SPECFINDDIR) | 0x80000000)))
				{
					// LZꂽ
					break;
				}
				recurse = (DWORD)dir & 0x80000000;
				(DWORD)dir &= 0x7FFFFFFF;
				// ɒǉ
				addChaindir(&Option.recentScandir, dir, recurse);
				//Jn
				findStart(hWnd, Option.recentScandir->dir, recurse);
			}
			break;
		case ID_FINDSTOP:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);

				if(mwv->tidFind)
					PostThreadMessage(mwv->tidFind, WM_APP, 0, 0);
			}
			break;
		case ID_CHECKSTATE:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));
				int max, i;

				max = ListView_GetItemCount(hListWnd);

				for(i = 0; i < max; i++)
				{
					if(ListView_GetCheckState(hListWnd, i))
						break;
				}

				if(i == max)
				{
					// ǂ`FbNĂȂ->`FbN
					for(i = 0; i < max; i++)
					{
						ListView_SetCheckState(hListWnd, i, TRUE);
					}
				}else
				{
					// ǂꂩ`FbNĂ->`FbN͂
					for(i = 0; i < max; i++)
					{
						ListView_SetCheckState(hListWnd, i, FALSE);
					}
				}
			}
			break;
		case ID_FILECOPY:
			if(!Option.TBCopyAlwaysAsk && Option.recentCopydir)
				copyStart(hWnd, Option.recentCopydir->dir);
			else
			{
				// TODO: ɂ܂Ƃ߂
				LPTSTR dir;

				if(!(dir = (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_REFERDIRECTORY), hWnd, DirreferDlgProc, (LPARAM)String(IDS_SPECFILECOPY))))
				{
					// LZꂽ
					break;
				}
				// ɒǉ
				addChaindir(&Option.recentCopydir, dir, FALSE);
				//Jn
				copyStart(hWnd, Option.recentCopydir->dir);
			}
			break;
		case ID_FILEMOVE:
			if(!Option.TBMoveAlwaysAsk && Option.recentMovedir)
				moveStart(hWnd, Option.recentMovedir->dir);
			else
			{
				// TODO: ɂ܂Ƃ߂
				LPTSTR dir;

				if(!(dir = (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_REFERDIRECTORY), hWnd, DirreferDlgProc, (LPARAM)String(IDS_SPECFILEMOVE))))
				{
					// LZꂽ
					break;
				}
				// ɒǉ
				addChaindir(&Option.recentMovedir, dir, FALSE);
				//Jn
				moveStart(hWnd, Option.recentMovedir->dir);
			}
			break;
		case ID_FILETRASH:
			{
				BOOL keystate = GetAsyncKeyState(VK_SHIFT) & 0x8000;

				if(Option.TBTrashIsDelete)
					keystate = !keystate;

				if(keystate)	// ShiftĂ
					deleteStart(hWnd, FALSE);	// 
				else	// łȂ
					deleteStart(hWnd, TRUE);	// S~
			}
			break;
		case ID_SETWALLPAPER:
			// TODO: ǎݒ
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));
				int id;
				TCHAR pictf[MAX_PATH];

				if((id = ListView_GetNextItem(hListWnd, -1, LVNI_FOCUSED)) == -1)
				{
					MessageBox(hWnd, String(IDS_NOFILESELECTEDTOSETWP), String(IDS_ERROR), MB_ICONERROR | MB_OK);
				}else
				{
					ListView_GetItemText(hListWnd, id, 3, pictf, sizeof(pictf));
					addEndYen(pictf);
					ListView_GetItemText(hListWnd, id, 0, pictf + lstrlen(pictf), sizeof(pictf) - lstrlen(pictf));

					SetWallpaper(pictf, Option.TBWallDefaultStyle, hWnd);
				}
			}
			break;
		case ID_SETTINGS:
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				NMTOOLBAR nmt;

				nmt.hdr.code = TBN_DROPDOWN;
				nmt.hdr.hwndFrom = Toolist_GetToolbar(Divider_GetWindow(mwv->hDividerWnd, 1));
				nmt.iItem = ID_SETTINGS;

				SendMessage(hWnd, WM_NOTIFY, 0, (LPARAM)&nmt);
			}
			break;
#ifdef OMAKE
		case ID_HELPME:
			{
				static BYTE mario = 4;
				static BYTE count = 0;

				if(++count == 100 || GetAsyncKeyState(VK_SHIFT) & 0x8000)
				{
					count = 0;
					mario++;
					PlaySound(MAKEINTRESOURCE(IDR_1UP), GetModuleHandle(NULL), SND_ASYNC | SND_RESOURCE);
				}else
					PlaySound(MAKEINTRESOURCE(IDR_COIN), GetModuleHandle(NULL), SND_ASYNC | SND_RESOURCE);
			}
			break;
#else
		case ID_HELPME:
			if(MessageBox(hWnd, String(IDS_OPENTEXTINSTEADOFHELP), String(IDS_CONFIRM), MB_ICONQUESTION | MB_YESNO) == IDYES)
				ShellExecute(hWnd, NULL, TEXT("scooper.txt"), NULL, NULL, SW_SHOWNORMAL);
			break;
#endif
		}
		break;
	case WM_NOTIFY:
		{
			NMHDR* nmh = (NMHDR*)lParam;

			if(nmh->code == TBN_DROPDOWN)
			{
				NMTOOLBAR* nmt = (NMTOOLBAR*)lParam;
				RECT rc;
				POINT p;
				HMENU hm;
				int ret;

				SendMessage(nmt->hdr.hwndFrom, TB_GETITEMRECT, TBGetIndexFromID(nmt->hdr.hwndFrom, nmt->iItem), (LPARAM)&rc);
				p.x = rc.left;
				p.y = rc.bottom;
				ClientToScreen(nmt->hdr.hwndFrom, &p);
reShowSettingMenu:
				switch(nmt->iItem)
				{
				case ID_SETCONDITION:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_CONDSETMENU)));

					if(CondSetroot)
					{
						ConditionSet* cs;
						int i;

						DeleteMenu(hm, ID_RECENT, MF_BYCOMMAND);

						for(cs = CondSetroot, i = 2; cs; cs = cs->next, i++)
						{
							InsertMenu(hm, GetMenuItemCount(hm), MF_BYPOSITION, i, cs->name);
						}
					}
					break;
					{
						Chaindir* root;

				// FileList Pane
				case ID_FINDSTART:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_FINDMENU)));
					// recentǉ
					root = Option.recentScandir;
					goto addRecent;
				case ID_FILECOPY:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_COPYMENU)));
					// recentǉ
					root = Option.recentCopydir;
					goto addRecent;
				case ID_FILEMOVE:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_MOVEMENU)));
					// recentǉ
					root = Option.recentMovedir;
					goto addRecent;
addRecent:
					{
						Chaindir* cd = root;
						int i;

						if(cd)
						{
							DeleteMenu(hm, ID_RECENT, MF_BYCOMMAND);
							for(i = 2; cd; cd = cd->next, i++)
							{
								InsertMenu(hm, GetMenuItemCount(hm), MF_BYPOSITION, i, cd->dir);
								if(nmt->iItem == ID_FINDSTART && cd->recurse)
								{
									MENUITEMINFO mii;

									mii.cbSize = sizeof(mii);
									mii.fMask = MIIM_STATE;
									mii.fState = MFS_CHECKED;

									SetMenuItemInfo(hm, GetMenuItemCount(hm) - 1, TRUE, &mii);
								}
							}
						}
					}
					break;
					}
				case ID_CHECKSTATE:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_CHECKSTATEMENU)));
					break;
				case ID_FILETRASH:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_TRASHMENU)));
					break;
				case ID_SETWALLPAPER:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_SETWPMENU)));
					break;
				case ID_SETTINGS:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_SETTINGSMENU)));
					// `FbN܂
					{
						MENUITEMINFO mii;

						mii.cbSize = sizeof(mii);
						mii.fMask = MIIM_STATE;

						GetMenuItemInfo(hm, ID_ALWAYSINPUTFINDDIR, FALSE, &mii);	mii.fState |= MF_CHECKED * Option.TBFindAlwaysAsk;								SetMenuItemInfo(hm, ID_ALWAYSINPUTFINDDIR, FALSE, &mii);
						GetMenuItemInfo(hm, ID_ALWAYSINPUTCOPYDIR, FALSE, &mii);	mii.fState |= MF_CHECKED * Option.TBCopyAlwaysAsk;								SetMenuItemInfo(hm, ID_ALWAYSINPUTCOPYDIR, FALSE, &mii);
						GetMenuItemInfo(hm, ID_ALWAYSINPUTMOVEDIR, FALSE, &mii);	mii.fState |= MF_CHECKED * Option.TBMoveAlwaysAsk;								SetMenuItemInfo(hm, ID_ALWAYSINPUTMOVEDIR, FALSE, &mii);
						GetMenuItemInfo(hm, ID_TRASHISDELETE, FALSE, &mii);			mii.fState |= MF_CHECKED * Option.TBTrashIsDelete;								SetMenuItemInfo(hm, ID_TRASHISDELETE, FALSE, &mii);

						GetMenuItemInfo(hm, ID_WALLDEFAULTSTRETCH, FALSE, &mii);	mii.fState |= (Option.TBWallDefaultStyle == WALL_STRETCH) ? MF_CHECKED : 0;		SetMenuItemInfo(hm, ID_WALLDEFAULTSTRETCH, FALSE, &mii);
						GetMenuItemInfo(hm, ID_WALLDEFAULTTILE, FALSE, &mii);		mii.fState |= (Option.TBWallDefaultStyle == WALL_TILE) ? MF_CHECKED : 0;		SetMenuItemInfo(hm, ID_WALLDEFAULTTILE, FALSE, &mii);
						GetMenuItemInfo(hm, ID_WALLDEFAULTCENTER, FALSE, &mii);		mii.fState |= (Option.TBWallDefaultStyle == WALL_CENTER) ? MF_CHECKED : 0;		SetMenuItemInfo(hm, ID_WALLDEFAULTCENTER, FALSE, &mii);

						GetMenuItemInfo(hm, ID_USEPREVIEWPANE, FALSE, &mii);		mii.fState |= MF_CHECKED * Option.UsePreviewPane;								SetMenuItemInfo(hm, ID_USEPREVIEWPANE, FALSE, &mii);

						GetMenuItemInfo(hm, ID_KEEPASPECTRATIO, FALSE, &mii);		mii.fState |= MF_CHECKED * Option.KeepAspectRatio;								SetMenuItemInfo(hm, ID_KEEPASPECTRATIO, FALSE, &mii);

						GetMenuItemInfo(hm, ID_BLACKONWHITE, FALSE, &mii);			mii.fState |= (Option.PreviewStretchMode == BLACKONWHITE) ? MF_CHECKED : 0;		SetMenuItemInfo(hm, ID_BLACKONWHITE, FALSE, &mii);
						GetMenuItemInfo(hm, ID_WHITEONBLACK, FALSE, &mii);			mii.fState |= (Option.PreviewStretchMode == WHITEONBLACK) ? MF_CHECKED : 0;		SetMenuItemInfo(hm, ID_WHITEONBLACK, FALSE, &mii);
						GetMenuItemInfo(hm, ID_COLORONCOLOR, FALSE, &mii);			mii.fState |= (Option.PreviewStretchMode == COLORONCOLOR) ? MF_CHECKED : 0;		SetMenuItemInfo(hm, ID_COLORONCOLOR, FALSE, &mii);
						GetMenuItemInfo(hm, ID_HALFTONE, FALSE, &mii);				mii.fState |= (Option.PreviewStretchMode == HALFTONE) ? MF_CHECKED : 0;			SetMenuItemInfo(hm, ID_HALFTONE, FALSE, &mii);

						GetMenuItemInfo(hm, ID_KEEPPREVIEWWINDOWPOS, FALSE, &mii);	mii.fState |= MF_CHECKED * Option.KeepPreviewWindowPos;							SetMenuItemInfo(hm, ID_KEEPPREVIEWWINDOWPOS, FALSE, &mii);

						GetMenuItemInfo(hm, ID_ENTERISEXEC, FALSE, &mii);			mii.fState |= (!Option.OldEnterOperation) ? MF_CHECKED : 0;						SetMenuItemInfo(hm, ID_ENTERISEXEC, FALSE, &mii);
						GetMenuItemInfo(hm, ID_ENTERISCHECK, FALSE, &mii);			mii.fState |= (Option.OldEnterOperation) ? MF_CHECKED : 0;						SetMenuItemInfo(hm, ID_ENTERISCHECK, FALSE, &mii);

						GetMenuItemInfo(hm, ID_UNCHECKWHENFOPSUCCESS, FALSE, &mii);	mii.fState |= MF_CHECKED * Option.UncheckWhenFOPSuccessful;						SetMenuItemInfo(hm, ID_UNCHECKWHENFOPSUCCESS, FALSE, &mii);

						GetMenuItemInfo(hm, ID_DORENAME, FALSE, &mii);				mii.fState |= (Option.HowtoWhenAlreadyExist == FOP_RENAME) ? MF_CHECKED : 0;	SetMenuItemInfo(hm, ID_DORENAME, FALSE, &mii);
						GetMenuItemInfo(hm, ID_DOOVERWRITE, FALSE, &mii);			mii.fState |= (Option.HowtoWhenAlreadyExist == FOP_OVERWRITE) ? MF_CHECKED : 0;	SetMenuItemInfo(hm, ID_DOOVERWRITE, FALSE, &mii);
						GetMenuItemInfo(hm, ID_DOTHROUGH, FALSE, &mii);				mii.fState |= (Option.HowtoWhenAlreadyExist == FOP_THROUGH) ? MF_CHECKED : 0;	SetMenuItemInfo(hm, ID_DOTHROUGH, FALSE, &mii);

						GetMenuItemInfo(hm, ID_RESHOWSETTING, FALSE, &mii);			mii.fState |= MF_CHECKED * Option.reShowSetting;								SetMenuItemInfo(hm, ID_RESHOWSETTING, FALSE, &mii);

						GetMenuItemInfo(hm, ID_LISTUPALL, FALSE, &mii);				mii.fState |= MF_CHECKED * Option.ListupAllFiles;								SetMenuItemInfo(hm, ID_LISTUPALL, FALSE, &mii);
						GetMenuItemInfo(hm, ID_FASTSCAN, FALSE, &mii);				mii.fState |= MF_CHECKED * Option.FastScan;										SetMenuItemInfo(hm, ID_FASTSCAN, FALSE, &mii);
					}
					break;
				case ID_HELPME:
					hm = MenuToPopup(LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_HELPMENU)));
					break;
				default:
					// oOĂ܂
					hm = NULL;
					break;
				}

				// \and
				if(ret = (int)TrackPopupMenu(hm, TPM_RETURNCMD | TPM_NONOTIFY, p.x, p.y, 0, hWnd, NULL))
				{
					switch(nmt->iItem)
					{
					// Condition Pane
					case ID_SETCONDITION:
						{
							struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
							HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));

							if(ret == 1)
							{	// Save
								LPTSTR name;

								if(!ListView_GetItemCount(hListWnd))
								{
									MessageBox(hWnd, String(IDS_NOCONDITIONSTOSAVE), String(IDS_ERROR), MB_ICONERROR | MB_OK);
									break;
								}

								if(!(name = (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_SAVECOND), hWnd, savecondDlgProc, (LPARAM)hListWnd)))
								{
									// LZꂽ
									break;
								}

								addConditionset(hListWnd, name);
							}else
							{	// Load
								// CondSet
								ConditionSet* cs, *pcs = NULL;
								int i;

								cs = CondSetroot;

								for(i = ret - 2; 0 < i; i--)
								{
									pcs = cs;
									cs = cs->next;
								}

								if(GetAsyncKeyState(VK_SHIFT) & 0x8000)
								{	// 폜
									TCHAR ts[256];	// TODO: Œł?

									wsprintf(ts, String(IDS_CONFIRMDELETECONDSET), cs->name);

									if(MessageBox(hWnd, ts, String(IDS_CONFIRM), MB_ICONWARNING | MB_YESNO) == IDYES)
									{	// 폜
										UINT i;

										if(!pcs)	// Ƃ肠Ǘ
											CondSetroot = cs->next;
										else
											pcs->next = cs->next;

										// J
										hfree(cs->name);

										for(i = 0; i < cs->itemcount; i++)
											hfree(cs->items[i]);
										hfree(cs->items);

										hfree(cs);
									}
								}else
								{
									// j[ړ
									if(!pcs)
										CondSetroot = cs->next;
									else
										pcs->next = cs->next;

									cs->next = CondSetroot;
									CondSetroot = cs;

									// [h
									ListView_DeleteAllItems(hListWnd);
									for(i = 0; i < (int)cs->itemcount; i++)
									{
										LV_ITEM lvi;
										TCHAR ts[32];

										lvi.mask = LVIF_TEXT | LVIF_PARAM;
										lvi.iItem = ListView_GetItemCount(hListWnd);
										lvi.iSubItem = 0;
										{
											ConditionItem* ci;

											ci = halloc(sizeof(ConditionItem));

											*ci = *cs->items[i];

											lvi.lParam = (LPARAM)ci;

											wsprintf(ts, TEXT("%d x %d"), ci->width, ci->height);
											lvi.pszText = ts;

											ListView_InsertItem(hListWnd, &lvi);

											ListView_SetItemText(hListWnd, lvi.iItem, 1, (LPTSTR)ConditionTextList[ci->cond]);
										}
									}
								}
							}
						}
						break;
					// FileList Pane
					case ID_FINDSTART:
					case ID_FILECOPY:
					case ID_FILEMOVE:
						{
							LPTSTR dir;
							BOOL recurse = FALSE;

							if(ret == 1)
							{
								// fBNgw
								LPCTSTR desc;

								switch(nmt->iItem)
								{
								case ID_FINDSTART: desc = String(IDS_SPECFINDDIR);	break;
								case ID_FILECOPY: desc = String(IDS_SPECFILECOPY);	break;
								case ID_FILEMOVE: desc = String(IDS_SPECFILEMOVE);	break;
								}

								if(!(dir = (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_REFERDIRECTORY), hWnd, DirreferDlgProc, (LPARAM)(DWORD)desc | (nmt->iItem == ID_FINDSTART ? 0x80000000 : 0) )))
								{
									// LZꂽ
									break;
								}
								// TODO: d

								recurse = (DWORD)dir & 0x80000000;
								(DWORD)dir &= 0x7FFFFFFF;
							}else
							{
								// idx(ret - 2)Rs[
								int i;
								Chaindir* cd, *pcd = NULL;
								Chaindir** root;

								switch(nmt->iItem)
								{
								case ID_FINDSTART:	root = &Option.recentScandir;	break;
								case ID_FILECOPY:	root = &Option.recentCopydir;	break;
								case ID_FILEMOVE:	root = &Option.recentMovedir;	break;
								}

								cd = *root;

								for(i = ret - 2; 0 < i; i--)
								{
									pcd = cd;
									cd = cd->next;
								}

								if(!pcd)
									*root = cd->next;
								else
									pcd->next = cd->next;

								dir = cd->dir;
								recurse = cd->recurse;

								hfree(cd);
							}

							// nmt->iItemɂ鏈
							switch(nmt->iItem)
							{
							case ID_FINDSTART:
								if(!(GetAsyncKeyState(VK_SHIFT) & 0x8000))
								{
									// ɒǉ
									addChaindir(&Option.recentScandir, dir, recurse);
									// Jn
									findStart(hWnd, dir, recurse);
								}
								break;
							case ID_FILECOPY:
								if(!(GetAsyncKeyState(VK_SHIFT) & 0x8000))
								{
									// ɒǉ
									addChaindir(&Option.recentCopydir, dir, FALSE);
									// Jn
									copyStart(hWnd, dir);
								}
								break;
							case ID_FILEMOVE:
								if(!(GetAsyncKeyState(VK_SHIFT) & 0x8000))
								{
									// ɒǉ
									addChaindir(&Option.recentMovedir, dir, FALSE);
									// ړJn
									moveStart(hWnd, dir);
								}
								break;
							}

							// ƂfindStartĂ邳...
							//hfree(dir);
						}
						break;
					case ID_CHECKSTATE:
						{
							struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
							HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));
							switch(ret)
							{
							case ID_CHECKALL:
								{
									int max, i;

									max = ListView_GetItemCount(hListWnd);

									for(i = 0; i < max; i++)
									{
										ListView_SetCheckState(hListWnd, i, TRUE);
									}
								}
								break;
							case ID_UNCHECKALL:
								{
									int max, i;

									max = ListView_GetItemCount(hListWnd);

									for(i = 0; i < max; i++)
									{
										ListView_SetCheckState(hListWnd, i, FALSE);
									}
								}
								break;
							case ID_INVERTCHECK:
								{
									int max, i;

									max = ListView_GetItemCount(hListWnd);

									for(i = 0; i < max; i++)
									{
										ListView_SetCheckState(hListWnd, i, !ListView_GetCheckState(hListWnd, i));
									}
								}
								break;
							}
						}
						break;
					case ID_FILETRASH:
						switch(ret)
						{
						case ID_GOTOTRASH:
							deleteStart(hWnd, TRUE);
							break;
						case ID_DELETENOW:
							deleteStart(hWnd, FALSE);
							break;
						}
						break;
					case ID_SETWALLPAPER:
						{
							if(ret == ID_SETWPNONE)
							{
								SetWallpaper(NULL, 0, hWnd);
							}else
							{
								struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
								HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));
								int id;
								TCHAR pictf[MAX_PATH];

								if((id = ListView_GetNextItem(hListWnd, -1, LVNI_FOCUSED)) == -1)
								{
									MessageBox(hWnd, String(IDS_NOFILESELECTEDTOSETWP), String(IDS_ERROR), MB_ICONERROR | MB_OK);
								}else
								{
									UINT mode;

									if(ret == ID_SETWPCENTER)	mode = 0;
									if(ret == ID_SETWPTILE)		mode = 1;
									if(ret == ID_SETWPSTRETCH)	mode = 2;

									ListView_GetItemText(hListWnd, id, 3, pictf, sizeof(pictf));
									addEndYen(pictf);
									ListView_GetItemText(hListWnd, id, 0, pictf + lstrlen(pictf), sizeof(pictf) - lstrlen(pictf));

									SetWallpaper(pictf, mode, hWnd);
								}
							}
						}
						break;
					case ID_SETTINGS:
						switch(ret)
						{
						case ID_ALWAYSINPUTFINDDIR:		Option.TBFindAlwaysAsk = !Option.TBFindAlwaysAsk;					break;
						case ID_ALWAYSINPUTCOPYDIR:		Option.TBCopyAlwaysAsk = !Option.TBCopyAlwaysAsk;					break;
						case ID_ALWAYSINPUTMOVEDIR:		Option.TBMoveAlwaysAsk = !Option.TBMoveAlwaysAsk;					break;
						case ID_TRASHISDELETE:			Option.TBTrashIsDelete = !Option.TBTrashIsDelete;					break;
						case ID_WALLDEFAULTSTRETCH:		Option.TBWallDefaultStyle = WALL_STRETCH;							break;
						case ID_WALLDEFAULTTILE:		Option.TBWallDefaultStyle = WALL_TILE;								break;
						case ID_WALLDEFAULTCENTER:		Option.TBWallDefaultStyle = WALL_CENTER;							break;
						case ID_USEPREVIEWPANE:			Option.UsePreviewPane = !Option.UsePreviewPane;						break;
						case ID_KEEPASPECTRATIO:
							{
								struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
								HWND pikture = Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 1);

								Option.KeepAspectRatio = !Option.KeepAspectRatio;
								InvalidateRect(pikture, NULL, FALSE);
							}
							break;
						case ID_BLACKONWHITE:
							{
								struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
								HWND pikture = Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 1);

								Option.PreviewStretchMode = BLACKONWHITE;
								InvalidateRect(pikture, NULL, FALSE);
							}
							break;
						case ID_WHITEONBLACK:
							{
								struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
								HWND pikture = Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 1);

								Option.PreviewStretchMode = WHITEONBLACK;
								InvalidateRect(pikture, NULL, FALSE);
							}
							break;
						case ID_COLORONCOLOR:
							{
								struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
								HWND pikture = Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 1);

								Option.PreviewStretchMode = COLORONCOLOR;
								InvalidateRect(pikture, NULL, FALSE);
							}
							break;
						case ID_HALFTONE:
							{
								struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
								HWND pikture = Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 1);

								Option.PreviewStretchMode = HALFTONE;
								InvalidateRect(pikture, NULL, FALSE);
							}
							break;
						case ID_KEEPPREVIEWWINDOWPOS:	Option.KeepPreviewWindowPos = !Option.KeepPreviewWindowPos;			break;
						case ID_ENTERISEXEC:			Option.OldEnterOperation = FALSE;									break;
						case ID_ENTERISCHECK:			Option.OldEnterOperation = TRUE;									break;
						case ID_UNCHECKWHENFOPSUCCESS:	Option.UncheckWhenFOPSuccessful = !Option.UncheckWhenFOPSuccessful;	break;
						case ID_DORENAME:				Option.HowtoWhenAlreadyExist = FOP_RENAME;							break;
						case ID_DOOVERWRITE:			Option.HowtoWhenAlreadyExist = FOP_OVERWRITE;						break;
						case ID_DOTHROUGH:				Option.HowtoWhenAlreadyExist = FOP_THROUGH;							break;
						case ID_RESHOWSETTING:			Option.reShowSetting = !Option.reShowSetting;						break;

						case ID_LISTUPALL:				Option.ListupAllFiles = !Option.ListupAllFiles;						break;
						case ID_FASTSCAN:				Option.FastScan = !Option.FastScan;									break;

						case ID_SPISETTING:				DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_SPISETTINGS), hWnd, SpisettingsDlgProc, 0);	break;

						case ID_SAVEININOW:				SaveConfig(FALSE);													break;
						}
						break;
					case ID_HELPME:
						switch(ret)
						{
						case ID_HELPINDEX:
							if(MessageBox(hWnd, String(IDS_OPENTEXTINSTEADOFHELP), String(IDS_CONFIRM), MB_ICONQUESTION | MB_YESNO) == IDYES)
								ShellExecute(hWnd, NULL, TEXT("scooper.txt"), NULL, NULL, SW_SHOWNORMAL);
							break;
						case ID_ABOUT:
							DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT), hWnd, NullDlgProc, 0);
							break;
						}
						break;
					}
				}

				DestroyMenu(hm);

				// TODO: ͂ЂǂB
				if(Option.reShowSetting && nmt->iItem == ID_SETTINGS && ret)
					goto reShowSettingMenu;
			}

			if(nmh->code == LVN_DELETEITEM)
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));

				if(nmh->hwndFrom == hListWnd)	// If conditionList...
				{
					NM_LISTVIEW* nml = (NM_LISTVIEW*)lParam;

					if(nml->lParam)
						hfree((void*)nml->lParam);
				}
			}

			if(nmh->code == NM_DBLCLK)
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));
				HWND hConditionListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0));
				HWND hExcludeListWnd = Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 0));

				if(nmh->hwndFrom == hConditionListWnd)	// If conditionList...
				{
					int sel;

					if((sel = ListView_GetNextItem(hConditionListWnd, -1, LVNI_FOCUSED)) != -1)
					{
						struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
						struct tagAddconditionDlgVal* adv = halloc(sizeof(struct tagAddconditionDlgVal));

						adv->hListWnd = hConditionListWnd;
						adv->id = sel;

						DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ADDCONDITION), hWnd, AddconditionDlgProc, (LPARAM)adv);

						// ^Cgo[
						RedrawWindow(hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW);
					}
				}
				if(nmh->hwndFrom == hExcludeListWnd)	// If excludeList...
				{
					int sel;

					if((sel = ListView_GetNextItem(hExcludeListWnd, -1, LVNI_FOCUSED)) != -1)
					{
						struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
						struct tagAddexcludeDlgVal* edv = halloc(sizeof(struct tagAddexcludeDlgVal));

						edv->hListWnd = hExcludeListWnd;
						edv->id = sel;

						DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ADDEXCLUDE), hWnd, AddexcludeDlgProc, (LPARAM)edv);

						// ^Cgo[
						RedrawWindow(hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW);
					}
				}
				if(nmh->hwndFrom == hListWnd)	// If fileList...
				{
					int i = ListView_GetNextItem(hListWnd, -1, LVNI_FOCUSED);
					TCHAR path[MAX_PATH];

					ListView_GetItemText(hListWnd, i, 3, path, sizeof(path));
					addEndYen(path);
					ListView_GetItemText(hListWnd, i, 0, path + lstrlen(path), sizeof(path) - lstrlen(path));

					ShellExecute(hWnd, NULL, path, NULL, NULL, SW_SHOWNORMAL);
				}
			}
			if(nmh->code == LVN_ITEMCHANGED)
			{
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));

				if(nmh->hwndFrom == hListWnd)	// If fileList...
				{
					/*
					int i = ListView_GetNextItem(hListWnd, -1, LVNI_FOCUSED);
					TCHAR path[MAX_PATH];

					ListView_GetItemText(hListWnd, i, 3, path, sizeof(path));
					addEndYen(path);
					ListView_GetItemText(hListWnd, i, 0, path + lstrlen(path), sizeof(path) - lstrlen(path));

					//ShellExecute(hWnd, NULL, path, NULL, NULL, SW_SHOWNORMAL);
					*/

					NM_LISTVIEW* nml = (NM_LISTVIEW*)lParam;

					if(nml->uChanged & LVIF_STATE && nml->uNewState & LVIS_FOCUSED)
					{
						HWND pikture = Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 1);
						TCHAR path[MAX_PATH];

						ListView_GetItemText(hListWnd, nml->iItem, 3, path, sizeof(path));
						addEndYen(path);
						ListView_GetItemText(hListWnd, nml->iItem, 0, path + lstrlen(path), sizeof(path) - lstrlen(path));

						SendMessage(pikture, WM_USER, 0, (LPARAM)path);
					}
				}
			}
			if(nmh->code == LVN_COLUMNCLICK)
			{
				NM_LISTVIEW* nml = (NM_LISTVIEW*)lParam;
				struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
				HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));
				struct tagFileListSortVal flsv;
				DWORD uParam = Toolist_GetListColumnStatus(hListWnd);

				if(HIWORD(uParam) == nml->iSubItem)
				{
					uParam++;
					if(2 <= LOWORD(uParam))
						uParam = 0xFFFF0000;
				}
				else
				{
					uParam = nml->iSubItem << 16;
				}

				Toolist_SetListColumnStatus(hListWnd, uParam);

				flsv.hListWnd = hListWnd;
				flsv.iCol = nml->iSubItem;

				ListView_SortItems(hListWnd, FileListSortCallback, (LPARAM)&flsv);
			}
			if(nmh->code == TTN_NEEDTEXT)
			{
				TOOLTIPTEXT* ttt = (TOOLTIPTEXT*)lParam;

				ttt->lpszText = (LPTSTR)ttt->hdr.idFrom;
			}
		}
		break;
	case WM_KEYDOWN:
		if((int)wParam == VK_RETURN)
		{
			struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
			HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));

			if(GetFocus() == hListWnd)
			{
				if(!Option.OldEnterOperation)
				{
					NMHDR nmh;

					nmh.hwndFrom = hListWnd;
					nmh.idFrom = 0;
					nmh.code = NM_DBLCLK;

					SendMessage(hWnd, WM_NOTIFY, 0, (LPARAM)&nmh);
				}else
				{
					int id;

					if((id = ListView_GetNextItem(hListWnd, -1, LVNI_FOCUSED)) != -1)
					{
						ListView_SetCheckState(hListWnd, id, !ListView_GetCheckState(hListWnd, id));
						ListView_SetItemState(hListWnd, id, 0, LVIS_FOCUSED | LVIS_SELECTED);
						ListView_SetItemState(hListWnd, id + 1, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
					}
				}
			}
		}
		if((int)wParam == VK_TAB)
		{
			struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
			HWND hWnds[] = {
				Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 0)),
				Toolist_GetListview(Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 0)),
				Divider_GetWindow(Divider_GetWindow(Divider_GetWindow(mwv->hDividerWnd, 0), 1), 1),
				Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1)),
				NULL
			};
			HWND current;
			int curid = -1;
			UINT i;

			current = GetFocus();

			for(i = 0; hWnds[i]; i++)
			{
				if(current == hWnds[i])
				{
					curid = i;
					break;
				}
			}
			curid++;
			if(hWnds[curid] == NULL)
				curid = 0;

			SetFocus(hWnds[curid]);
		}
		break;
	case WM_CONTEXTMENU:
		// TODO: RightClickTechnology
		{
			struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
			HWND hListWnd = Toolist_GetListview(Divider_GetWindow(mwv->hDividerWnd, 1));

			if(GetFocus()/*(HWND)wParam*/ == hListWnd)
			{
				int id = ListView_GetNextItem(hListWnd, -1, LVNI_ALL | LVNI_FOCUSED);

				if(id != -1)
				{
					TCHAR path[MAX_PATH];
					ITEMIDLIST* idl;
					IShellFolder* pdesk;
					LPCONTEXTMENU cm;

					ListView_GetItemText(hListWnd, id, 3, path, sizeof(path));
					addEndYen(path);
					ListView_GetItemText(hListWnd, id, 0, path + lstrlen(path), sizeof(path) - lstrlen(path));

					// path is target
					SHGetDesktopFolder(&pdesk);
					idl = GetItemIDList(hWnd, pdesk, path);

					// http://mtamaki.cocolog-nifty.com/blog/2005/08/index.html
					{
						LPITEMIDLIST preidl = idl, curidl;
						IShellFolder* cursf = pdesk;

						do
						{
							IShellFolder* pTemp;

							curidl = CoTaskMemAlloc(preidl->mkid.cb + sizeof(USHORT));	// SHITEMID.mkid.cb = USHORT

							// will be inline
							memcpy(curidl, preidl, preidl->mkid.cb);
							((LPITEMIDLIST)((BYTE*)curidl + curidl->mkid.cb))->mkid.cb = 0;

							// TODO: error check
							cursf->lpVtbl->BindToObject(cursf, curidl, NULL, &IID_IShellFolder, &pTemp);
							cursf->lpVtbl->Release(cursf);
							cursf = pTemp;
							CoTaskMemFree(curidl);

							preidl = (LPITEMIDLIST)((BYTE*)preidl + preidl->mkid.cb);
						}while(((LPITEMIDLIST)((BYTE*)preidl + preidl->mkid.cb))->mkid.cb != 0);

						// Now cursf is parent, preidl is filename.
						// TODO: This is KH patch...
						pdesk = cursf;
						{
							LPITEMIDLIST xidl;

							xidl = CoTaskMemAlloc(preidl->mkid.cb + sizeof(USHORT));
							// will be inline
							memcpy(xidl, preidl, preidl->mkid.cb);
							((LPITEMIDLIST)((BYTE*)xidl + xidl->mkid.cb))->mkid.cb = 0;

							CoTaskMemFree(idl);
							idl = xidl;
						}
					}

					if(SUCCEEDED(pdesk->lpVtbl->GetUIObjectOf(pdesk, hWnd, 1, &idl, &IID_IContextMenu, NULL, &cm)))
					{
						struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);
						HMENU hMenu;
						LPCONTEXTMENU2 cm2;

						// TODO: case failed...
						cm->lpVtbl->QueryInterface(cm, &IID_IContextMenu2, &cm2);
						// QueryInterface(IContextMenu2)Ƃ͗p炵B
						cm->lpVtbl->Release(cm);

						mwv->cm2 = cm2;

						hMenu = CreatePopupMenu();

						if(SUCCEEDED(cm2->lpVtbl->QueryContextMenu(cm2, hMenu, 0, 1, 0x7FFF, CMF_NORMAL/*EXPLORE*/)))
						{
							// http://www.kab-studio.biz/Programing/Codian/ShellExtension/07.html
							// http://hp.vector.co.jp/authors/VA016117/explorer4.html
							int idCmd;

							idCmd = TrackPopupMenu(hMenu, TPM_RETURNCMD, LOWORD(lParam), HIWORD(lParam), 0, hWnd, NULL);

							DestroyMenu(hMenu);

							if (idCmd){
								CMINVOKECOMMANDINFO cmi;

								//Jt@C̃IvVƂ\TCYƂ̐ݒłB
								cmi.cbSize = sizeof(CMINVOKECOMMANDINFO);
								cmi.fMask  = 0;
								cmi.hwnd   = hWnd;
								cmi.lpVerb = MAKEINTRESOURCE(idCmd - 1);
								cmi.lpParameters = NULL;
								cmi.lpDirectory  = NULL;
								cmi.nShow        = SW_SHOWNORMAL;
								cmi.dwHotKey     = 0;
								cmi.hIcon        = NULL;
								//̃R}hŎs܂
								if(!SUCCEEDED(cm2->lpVtbl->InvokeCommand(cm2, &cmi)))  
									_asm nop;	// G[
							}
						}

						mwv->cm2 = NULL;

						cm2->lpVtbl->Release(cm2);
					}

					pdesk->lpVtbl->Release(pdesk);
					CoTaskMemFree(idl);
				}
			}
		}
		break;

	case WM_INITMENUPOPUP:
	case WM_DRAWITEM:
	//case WM_MENUCHAR:	// need?
	case WM_MEASUREITEM:
		{
			struct tagMainWndVal* mwv = (struct tagMainWndVal*)GetWindowLong(hWnd, 0);

			if(mwv->cm2)
				mwv->cm2->lpVtbl->HandleMenuMsg(mwv->cm2, msg, wParam, lParam);
		}
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

HWND makeMainWnd(void)
{
	WNDCLASSEX wc = {0};
	HWND hWnd;

	wc.cbSize = sizeof(wc);
	wc.cbWndExtra = sizeof(struct tagMainWndVal*);
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hInstance = GetModuleHandle(NULL);
	wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_APP));
	wc.lpfnWndProc = MainWndProc;
	wc.lpszClassName = TEXT("scooperMainWnd");
	wc.style = CS_HREDRAW | CS_VREDRAW;

	// WindowClasso^
	if(!RegisterClassEx(&wc))
	{
		MessageBox(NULL, String(IDS_FAILEDREGISTERCLASSEX), String(IDS_FATAL), MB_ICONERROR | MB_OK);
		return NULL;
	}

	// CEBhE쐬
	if(!(hWnd = CreateWindowEx(0, wc.lpszClassName, String(IDS_APPTITLE), WS_SYSMENU | WS_SIZEBOX | WS_MINIMIZEBOX | WS_MAXIMIZEBOX, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, wc.hInstance, NULL)))
	{
		MessageBox(NULL, String(IDS_FAILEDCREATEWINDOWEX), String(IDS_FATAL), MB_ICONERROR | MB_OK);
		return NULL;
	}

	return hWnd;
}

BOOL LoadConfig(void)
{
	TCHAR inifile[MAX_PATH];

	GetModuleFileName(NULL, inifile, sizeof(inifile));
	lstrcpy((LPTSTR)lastchar(inifile, TEXT('.')), TEXT(".ini"));

	GetPrivateProfileString(TEXT("scooper"), TEXT("SPIDir"), TEXT("."), gSpiDir, sizeof(gSpiDir), inifile);

	Option.UsePreviewPane = GetPrivateProfileInt(TEXT("scooper"), TEXT("UsePreviewPane"), TRUE, inifile);
	Option.KeepAspectRatio = GetPrivateProfileInt(TEXT("scooper"), TEXT("KeepAspectRatio"), TRUE, inifile);
	Option.PreviewStretchMode = GetPrivateProfileInt(TEXT("scooper"), TEXT("PreviewStretchMode"), HALFTONE, inifile);
	Option.KeepPreviewWindowPos = GetPrivateProfileInt(TEXT("scooper"), TEXT("KeepPreviewWindowPos"), TRUE, inifile);
	Option.UncheckWhenFOPSuccessful = GetPrivateProfileInt(TEXT("scooper"), TEXT("UncheckWhenFOPSuccessful"), TRUE, inifile);
	Option.HowtoWhenAlreadyExist = GetPrivateProfileInt(TEXT("scooper"), TEXT("HowtoWhenAlreadyExist"), FOP_THROUGH, inifile);
	Option.ListupAllFiles = GetPrivateProfileInt(TEXT("scooper"), TEXT("ListupAllFiles"), FALSE, inifile);
	Option.FastScan = GetPrivateProfileInt(TEXT("scooper"), TEXT("FastScan"), FALSE, inifile);
	Option.OldEnterOperation = GetPrivateProfileInt(TEXT("scooper"), TEXT("OldEnterOperation"), FALSE, inifile);
	Option.TBFindAlwaysAsk = GetPrivateProfileInt(TEXT("scooper"), TEXT("TBFindAlwaysAsk"), FALSE, inifile);
	Option.TBCopyAlwaysAsk = GetPrivateProfileInt(TEXT("scooper"), TEXT("TBCopyAlwaysAsk"), FALSE, inifile);
	Option.TBMoveAlwaysAsk = GetPrivateProfileInt(TEXT("scooper"), TEXT("TBMoveAlwaysAsk"), FALSE, inifile);
	Option.TBTrashIsDelete = GetPrivateProfileInt(TEXT("scooper"), TEXT("TBTrashIsDelete"), FALSE, inifile);
	Option.TBWallDefaultStyle = GetPrivateProfileInt(TEXT("scooper"), TEXT("TBWallDefaultStyle"), WALL_STRETCH, inifile);
	Option.reShowSetting = GetPrivateProfileInt(TEXT("scooper"), TEXT("reShowSetting"), FALSE, inifile);

	Option.recentScandirItems = GetPrivateProfileInt(TEXT("scooper"), TEXT("recentScandirItems"), 5, inifile);
	Option.recentCopydirItems = GetPrivateProfileInt(TEXT("scooper"), TEXT("recentCopydirItems"), 5, inifile);
	Option.recentMovedirItems = GetPrivateProfileInt(TEXT("scooper"), TEXT("recentMovedirItems"), 5, inifile);

	// ǂݍ
	Option.recentScandir = NULL;
	Option.recentCopydir = NULL;
	Option.recentMovedir = NULL;

	{
		Chaindir** cds[] = {&Option.recentScandir, &Option.recentCopydir, &Option.recentMovedir, NULL}, ***cd = cds;
		LPCTSTR cdsnm[] = {TEXT("recentScandir%d"), TEXT("recentCopydir%d"), TEXT("recentMovedir%d"), NULL}, *cdnm = cdsnm;

		for(; *cd; (cd)++, cdnm++)
		{
			Chaindir* pre;
			int i;

			for(pre = NULL, i = 0; ; i++)
			{
				TCHAR ts[MAX_PATH];
				Chaindir* cur;

				wsprintf(ts, *cdnm, i);
				GetPrivateProfileString(TEXT("scooper"), ts, TEXT(""), ts, sizeof(ts), inifile);

				if(!lstrlen(ts))
					break;

				cur = halloc(sizeof(Chaindir));

				{
					LPTSTR duptxt;

					duptxt = halloc(sizeof(TCHAR) * (lstrlen(ts) + 1));
					lstrcpy(duptxt, ts);

					cur->dir = duptxt;

					if(cd == cds)	// if first item
					{
						wsprintf(ts, TEXT("recentScandirRecurse%d"), i);
						cur->recurse = GetPrivateProfileInt(TEXT("scooper"), ts, 0, inifile);
					}
				}
				cur->next = NULL;

				if(!pre)
					**cd = cur;
				else
					pre->next = cur;

				pre = cur;
			}
		}
	}

	// ConditionSetǂݍ
	{
		int i;
		ConditionSet* pre = NULL;

		for(i = 0; ; i++)
		{
			TCHAR ts[MAX_PATH];	// TODO: OMAX_PATH͂Ȃ낤B
			ConditionSet* cs;

			wsprintf(ts, TEXT("ConditionSet%d.Name"), i);
			GetPrivateProfileString(TEXT("scooper"), ts, TEXT(""), ts, sizeof(ts), inifile);

			if(!lstrlen(ts))
				break;

			cs = halloc(sizeof(ConditionSet));

			{
				LPTSTR duptxt;

				duptxt = halloc(sizeof(TCHAR) * (lstrlen(ts) + 1));
				lstrcpy(duptxt, ts);

				cs->name = duptxt;
			}

			for(cs->itemcount = 0; ; cs->itemcount++)
			{
				wsprintf(ts, TEXT("ConditionSet%d.%d.width"), i, cs->itemcount);
				GetPrivateProfileString(TEXT("scooper"), ts, TEXT(""), ts, sizeof(ts), inifile);

				if(!lstrlen(ts))
					break;
			}

			if(!cs->itemcount)
			{	// Assert
				MessageBox(NULL, String(IDS_ITEMCOUNTISZERO), String(IDS_FATAL), MB_ICONERROR | MB_OK);
				return FALSE;
			}else
			{
				UINT j;

				cs->items = halloc(sizeof(ConditionItem*) * cs->itemcount);

				for(j = 0; j < cs->itemcount; j++)
				{
					cs->items[j] = halloc(sizeof(ConditionItem));

					// ǂݍ
					wsprintf(ts, TEXT("ConditionSet%d.%d.width"), i, j);
					cs->items[j]->width = GetPrivateProfileInt(TEXT("scooper"), ts, 0, inifile);
					wsprintf(ts, TEXT("ConditionSet%d.%d.height"), i, j);
					cs->items[j]->height = GetPrivateProfileInt(TEXT("scooper"), ts, 0, inifile);
					wsprintf(ts, TEXT("ConditionSet%d.%d.cond"), i, j);
					cs->items[j]->cond = GetPrivateProfileInt(TEXT("scooper"), ts, 0, inifile);
				}
			}

			cs->next = NULL;

			if(!pre)
				CondSetroot = cs;
			else
				pre->next = cs;

			pre = cs;
		}
	}

	// SPIݒǂݍ
	{
		// tO
		SUSIEPLUGIN* spi, *newroot = NULL, *cur = NULL;
		UINT i;

		for(spi = SPIroot; spi; spi = spi->next)
		{
			TCHAR ts[256];
			int val;

			lstrcpy(ts, spi->ModuleName);
			lstrlwr(ts);

			val = GetPrivateProfileInt(TEXT("plugins"), ts, TRUE, inifile);

			spi->use = val & 1;
			spi->num = val >> 1;
		}

		// ёւ
		for(i = 0; SPIroot; i++)
		{
			SUSIEPLUGIN* pre = NULL;

			for(spi = SPIroot; spi; )
			{
				if(spi->num == i)
				{
					SUSIEPLUGIN* nx;

					if(pre == NULL)
						SPIroot = spi->next;
					else
						pre->next = spi->next;

					// spi͌ǗB

					nx = spi->next;
					spi->next = NULL;

					// ǉ
					if(!cur)
						newroot = spi;
					else
						cur->next = spi;

					cur = spi;

					spi = nx;

					// 
					continue;
				}

				pre = spi, spi = spi->next;
			}
		}

		SPIroot = newroot;
	}

	return TRUE;
}

void SaveConfig(BOOL last)
{
	TCHAR inifile[MAX_PATH];

	GetModuleFileName(NULL, inifile, sizeof(inifile));
	lstrcpy((LPTSTR)lastchar(inifile, TEXT('.')), TEXT(".ini"));

	WritePrivateProfileInt(TEXT("scooper"), TEXT("UsePreviewPane"), Option.UsePreviewPane, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("KeepAspectRatio"), Option.KeepAspectRatio, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("PreviewStretchMode"), Option.PreviewStretchMode, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("KeepPreviewWindowPos"), Option.KeepPreviewWindowPos, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("UncheckWhenFOPSuccessful"), Option.UncheckWhenFOPSuccessful, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("HowtoWhenAlreadyExist"), Option.HowtoWhenAlreadyExist, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("ListupAllFiles"), Option.ListupAllFiles, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("FastScan"), Option.FastScan, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("OldEnterOperation"), Option.OldEnterOperation, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("TBFindAlwaysAsk"), Option.TBFindAlwaysAsk, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("TBCopyAlwaysAsk"), Option.TBCopyAlwaysAsk, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("TBMoveAlwaysAsk"), Option.TBMoveAlwaysAsk, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("TBTrashIsDelete"), Option.TBTrashIsDelete, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("TBWallDefaultStyle"), Option.TBWallDefaultStyle, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("reShowSetting"), Option.reShowSetting, inifile);

	WritePrivateProfileInt(TEXT("scooper"), TEXT("recentScandirItems"), Option.recentScandirItems, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("recentCopydirItems"), Option.recentCopydirItems, inifile);
	WritePrivateProfileInt(TEXT("scooper"), TEXT("recentMovedirItems"), Option.recentMovedirItems, inifile);

	// o+n
	{
		Chaindir* cds[] = {Option.recentScandir, Option.recentCopydir, Option.recentMovedir, NULL}, **cd = cds;
		LPCTSTR cdsnm[] = {TEXT("recentScandir%d"), TEXT("recentCopydir%d"), TEXT("recentMovedir%d"), NULL}, *cdnm = cdsnm;

		for(; *cd; cd++, cdnm++)
		{
			Chaindir* cur;
			int i;

			for(cur = *cd, i = 0; cur; i++)
			{
				Chaindir* next;
				TCHAR ts[64];

				wsprintf(ts, *cdnm, i);
				WritePrivateProfileString(TEXT("scooper"), ts, cur->dir, inifile);
				if(cd == cds)	// if first item
				{
					wsprintf(ts, TEXT("recentScandirRecurse%d"), i);
					WritePrivateProfileInt(TEXT("scooper"), ts, cur->recurse, inifile);
				}

				next = cur->next;
				if(last)
				{
					hfree(cur->dir);
					hfree(cur);
				}
				cur = next;
			}
			// 񃍁[hȂ悤...
			{
				TCHAR ts[64];

				wsprintf(ts, *cdnm, i);
				WritePrivateProfileString(TEXT("scooper"), ts, NULL, inifile);
			}
		}
	}

	// ConditionSeto+n
	{
		ConditionSet* cs;
		int i;

		for(cs = CondSetroot, i = 0; cs; i++)
		{
			ConditionSet* csnext;
			TCHAR ts[64];
			UINT j;

			wsprintf(ts, TEXT("ConditionSet%d.Name"), i);
			WritePrivateProfileString(TEXT("scooper"), ts, cs->name, inifile);
			if(last)
				hfree(cs->name);

			for(j = 0; j < cs->itemcount; j++)
			{
				wsprintf(ts, TEXT("ConditionSet%d.%d.width"), i, j);
				WritePrivateProfileInt(TEXT("scooper"), ts, cs->items[j]->width, inifile);
				wsprintf(ts, TEXT("ConditionSet%d.%d.height"), i, j);
				WritePrivateProfileInt(TEXT("scooper"), ts, cs->items[j]->height, inifile);
				wsprintf(ts, TEXT("ConditionSet%d.%d.cond"), i, j);
				WritePrivateProfileInt(TEXT("scooper"), ts, cs->items[j]->cond, inifile);

				if(last)
					hfree(cs->items[j]);
			}
			// 񕜊h~
			{
				TCHAR ts[64];

				wsprintf(ts, TEXT("ConditionSet%d.%d.width"), i, j);
				WritePrivateProfileString(TEXT("scooper"), ts, NULL, inifile);
			}
			if(last)
				hfree(cs->items);

			csnext = cs->next;
			if(last)
				hfree(cs);
			cs = csnext;
		}
		// 񕜊h~
		{
			TCHAR ts[64];

			wsprintf(ts, TEXT("ConditionSet%d.Name"), i);
			WritePrivateProfileString(TEXT("scooper"), ts, NULL, inifile);
		}
	}

	// SPIݒۑ
	{
		// tO
		SUSIEPLUGIN* spi;
		UINT num;

		for(spi = SPIroot, num = 0; spi; spi = spi->next, num++)
		{
			TCHAR ts[256];

			lstrcpy(ts, spi->ModuleName);
			lstrlwr(ts);

			WritePrivateProfileInt(TEXT("plugins"), ts, (num << 1) | spi->use, inifile);
		}
	}

	return;
}

void WinMainCRTStartup(void)
{
	MSG msg;
	HWND hWnd;

	InitCommonControls();
	CoInitialize(NULL);

	if(!dividerInit())
	{
		MessageBox(NULL, String(IDS_FAILEDDIVIDERINIT), String(IDS_FATAL), MB_ICONERROR | MB_OK);
		goto FinDivider;
	}

	if(!toolistInit())
	{
		MessageBox(NULL, String(IDS_FAILEDTOOLISTINIT), String(IDS_FATAL), MB_ICONERROR | MB_OK);
		goto FinToolist;
	}

	if(!piktureInit())
	{
		MessageBox(NULL, String(IDS_FAILEDPIKTUREINIT), String(IDS_FATAL), MB_ICONERROR | MB_OK);
		goto FinPikture;
	}

	if(!(hWnd = makeMainWnd()))
		goto FinMainwnd;

	// Ƃ肠SPIfBNgǂ
	{
		TCHAR inifile[MAX_PATH];

		GetModuleFileName(NULL, inifile, sizeof(inifile));
		lstrcpy((LPTSTR)lastchar(inifile, TEXT('.')), TEXT(".ini"));

respec:
		GetPrivateProfileString(TEXT("scooper"), TEXT("SPIDir"), TEXT(""), gSpiDir, sizeof(gSpiDir), inifile);

		if(!lstrlen(gSpiDir))
		{
			LPCTSTR dir;
			if(!(dir = (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_REFERDIRECTORY), NULL, DirreferDlgProc, (LPARAM)String(IDS_SPECSPIDIR))))
			{
				// LZꂽ
				lstrcpy(gSpiDir, TEXT("."));
			}else
			{
				lstrcpy(gSpiDir, dir);
				hfree((LPTSTR)dir);

				WritePrivateProfileString(TEXT("scooper"), TEXT("SPIDir"), gSpiDir, inifile);
			}
		}

#ifdef _DEBUG
		if(GetAsyncKeyState(VK_SHIFT) & 0x8000)
		{
			if(MessageBox(NULL, String(IDS_SKIPSCANSPI), String(IDS_CONFIRM), MB_ICONWARNING | MB_YESNO) == IDNO)
				goto respec;
		}else
		{
#endif
			if(!scanSusiePlugins())
			{
				if(MessageBox(NULL, String(IDS_NOSPI), String(IDS_WARNING), MB_ICONWARNING | MB_YESNO) == IDYES)
				{
					WritePrivateProfileString(TEXT("scooper"), TEXT("SPIDir"), NULL, inifile);
					goto respec;
				}
			}
#ifdef _DEBUG
		}
#endif
	}

	// ̑̐ݒǂݍ
	if(!LoadConfig())
		goto FinSetting;

	// CEBhE\
	{
		STARTUPINFO si;

		GetStartupInfo(&si);
		ShowWindow(hWnd, si.wShowWindow);
	}

	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	// ->I

	// ݒۑ
	SaveConfig(TRUE);

	// (sn܂)ォÂ^C
	freeSusiePluginChain(SPIroot);
FinSetting:
	// MainWndDestroyׂ?(IłDestroyĂƎv޽)
FinMainwnd:	
	piktureTerminate();
FinPikture:	// piktureInitĂȂ
	toolistTerminate();
FinToolist:	// toolistInitĂȂ
	dividerTerminate();
FinDivider:	// dividerInitĂȂ

	FreeLoadedStrings();

	CoUninitialize();

	ExitProcess(0);
}
