#include <windows.h>
#include <commctrl.h>

#include "resource.h"
#include "common.h"
#include "toolist.h"

struct tlval{
	HWND hWndSendto;

	HWND hToolbar;
	HWND hListview;

	DWORD ListColumnStatus;
};

HIMAGELIST hToolbarImage = NULL;

LRESULT CALLBACK KeyPumpSubProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_APP:
		SetWindowLong(hWnd, GWL_USERDATA, (LONG)GetWindowLong(hWnd, GWL_WNDPROC));
		SetWindowLong(hWnd, GWL_WNDPROC, (LONG)KeyPumpSubProc);
		return 0;
	case WM_KEYDOWN:
	case WM_KEYUP:
		if(
			(int)wParam == VK_RETURN ||
			(int)wParam == VK_TAB ||
			0)
		{
			SendMessage(GetParent(hWnd), msg, wParam, lParam);
			return 0;
		}
	}

	return CallWindowProc((WNDPROC)GetWindowLong(hWnd, GWL_USERDATA), hWnd, msg, wParam, lParam);
}

LRESULT CALLBACK ToolistWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE:
		{
			struct tlval* tlv;

			if(!(tlv = halloc(sizeof(struct tlval))))
				return -1;	// oops

			SetWindowLong(hWnd, 0, (LONG)tlv);

			tlv->hWndSendto = (HWND)((CREATESTRUCT*)lParam)->lpCreateParams;

			// c[o[쐬
			tlv->hToolbar = CreateWindowEx(0, TOOLBARCLASSNAME, NULL, WS_VISIBLE | WS_CHILD | CCS_TOP | CCS_NODIVIDER | TBSTYLE_FLAT | TBSTYLE_TOOLTIPS, 0, 0, 0, 0, hWnd, NULL, GetModuleHandle(NULL), NULL);
			// KeyPumpݒ
			KeyPumpSubProc(tlv->hToolbar, WM_APP, 0, 0);
			// Ă邩
			SendMessage(tlv->hToolbar, TB_BUTTONSTRUCTSIZE, sizeof(TBBUTTON), 0);
			// C[Wݒ
			SendMessage(tlv->hToolbar, TB_SETIMAGELIST, 0, (LPARAM)hToolbarImage);
			// hbv_E\ł悤ɐݒ
			SendMessage(tlv->hToolbar, TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS);

			// Xgr[쐬
			tlv->hListview = CreateWindowEx(0, WC_LISTVIEW, NULL, WS_VISIBLE | WS_CHILD | LVS_REPORT | LVS_SHOWSELALWAYS, 0, 0, 0, 0, hWnd, NULL, GetModuleHandle(NULL), NULL);
			// KeyPumpݒ
			KeyPumpSubProc(tlv->hListview, WM_APP, 0, 0);
			// ݒ肵Ă邩 TODO:`FbN{bNXǂ
			ListView_SetExtendedListViewStyle(tlv->hListview, LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
			// UserData
			//SetWindowLong(tlv->hListview, GWL_USERDATA, 0xFFFF0000);
			tlv->ListColumnStatus = 0xFFFF0000;
		}

		break;
	case WM_DESTROY:
		{
			//struct tlval* tlv = (struct tlval*)GetWindowLong(hWnd, 0);

			//ListView_DeleteAllItems(tlv->hListview);
			hfree((void*)GetWindowLong(hWnd, 0));
		}
		break;
	case WM_COMMAND:
	case WM_NOTIFY:
	case WM_KEYDOWN:
	case WM_KEYUP:
		{	// Ɋۓ
			struct tlval* tlv = (struct tlval*)GetWindowLong(hWnd, 0);

			return SendMessage(tlv->hWndSendto, msg, wParam, lParam);
			//break;
		}
	case WM_SIZE:
		{
			struct tlval* tlv = (struct tlval*)GetWindowLong(hWnd, 0);
			RECT rc;

			// I[gTCY
			SendMessage(tlv->hToolbar, WM_SIZE, wParam, lParam);
			GetClientRect(tlv->hToolbar, &rc);
			SetWindowPos(tlv->hListview, NULL, 0, rc.bottom, LOWORD(lParam), HIWORD(lParam) - rc.bottom, SWP_NOZORDER);
		}
		break;
	case WM_USER:
		// c[o[ƃXgr[̃nh擾
		{
			struct tlval* tlv = (struct tlval*)GetWindowLong(hWnd, 0);

			switch(wParam)
			{
			case 0:
				return (LRESULT)tlv->hToolbar;
			case 1:
				return (LRESULT)tlv->hListview;
			case 2:
				return (LRESULT)tlv->ListColumnStatus;
			case 3:
				return (LRESULT)(tlv->ListColumnStatus = lParam);
			}

			return (LRESULT)NULL;
		}
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

BOOL toolistInit(void)
{
	WNDCLASSEX wc = {0};

	wc.cbSize = sizeof(wc);
	wc.cbWndExtra = sizeof(void*);
	wc.hInstance = GetModuleHandle(NULL);
	wc.lpfnWndProc = ToolistWndProc;
	wc.lpszClassName = WC_TOOLIST;

	if(!RegisterClassEx(&wc))
		return FALSE;

	if(!(hToolbarImage = ImageList_LoadImage(GetModuleHandle(NULL), MAKEINTRESOURCE(IDB_TBICON), 16, 4, RGB(255, 0, 255), IMAGE_BITMAP, LR_DEFAULTCOLOR)))
		return FALSE;

	return TRUE;
}

void toolistTerminate(void)
{
	ImageList_Destroy(hToolbarImage);

	return;
}
